<?php
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+

$TMDBAPI = "b626260be86175272e48fa6347e58100";
$TVDBAPI = "BAA99452E3BA7E07";
$convert_location = "/usr/bin/convert";
$datadir = "data";

class XmlToJson {
	public function Parse ($url) {
		$fileContents= file_get_contents($url);
		$fileContents = str_replace(array("\n", "\r", "\t"), '', $fileContents);
		$fileContents = trim(str_replace('"', "'", $fileContents));
		$simpleXml = simplexml_load_string($fileContents);
		$json = json_encode($simpleXml);
		return $json;
	}
}

function LastBrowsed()
{
    global $datadir;
    if (file_exists($datadir . '/last_browsed') && filesize($datadir . '/last_browsed') > 0) {
        $filestring = file_get_contents($datadir . '/last_browsed');
        $filearray = explode("\n", $filestring);
        return $filearray[0];
    }
}

function SetLastBrowsed($dir)
{
    global $datadir;
    if (is_writable($datadir)) {
        file_put_contents($datadir . "/last_browsed", $dir);
    }
}

function searchIMDB($string)
{
    foreach ($skip_keywords as $skip_key) {
        $string = str_replace($skip_key, "", strtoupper($string));
        $string = str_replace("..", ".", $string);
    }

    $search = array(".", "-", "_", "[", "]", "(", ")", "  ");
    $replace = array(" ", " ", " ", " ", " ", " ", " ", " ");
    $string = trim(str_replace($search, $replace, $string));
    for ($i = 1950; $i < 3000; $i++)
        $string = str_replace($i, "(" . $i . ")", $string);
    $string = explode(")", $string);
    if (count($string) > 1)
        $string = $string[0] . ")";
    else
        $string = $string[0];

    $command = "wget -q 'http://www.imdb.com/find?s=tt&q=" . $string . "&x=0&y=0' -qO-";
    $imdb_content = shell_exec($command);
    if (stristr($imdb_content, "No Matches."))
        return "No Matches";
    else
        return getIMDBid($imdb_content);
}

function array_push_assoc($array, $key, $value)
{
    $array[$key] = $value;
    return $array;
}

function scan_dir($dir)
{
    $dh = opendir($dir);
    while (false !== ($filename = readdir($dh))) {
        $files[] = $filename;
    }
    sort($files);
    return $files;
}

function getXMLSafe($input)
{
    return html_entity_decode(str_replace('&#x27;', '&#39;', str_replace('&apos;', '&#39;', $input)), ENT_QUOTES);
    //return str_replace("&#039;", "&apos;", htmlentities(html_entity_decode($input), ENT_QUOTES));
    //return str_replace("&#039;", "'", $input);
}

function setXMLSafe($input)
{
    return str_replace("&#039;", "&apos;", htmlentities($input, ENT_QUOTES));
}

function getIMDBdata($imdbid)
{
    global $tmpdir;

    $nmj_data = array();

    $command = "wget 'http://www.omdbapi.com/?i=".$imdbid."&plot=full&r=json' -qO-";
    $data = shell_exec($command);
    $json_parser = json_decode($data, true);

    foreach($json_parser as $key => $tdata){
        if ($key == 'Title')
            $nmj_data['TITLE'] = $tdata;
        else if ($key == 'Year')
	    $nmj_data['YEAR'] = $tdata;
        else if ($key == 'imdbID')
	    $nmj_data['TTID'] = $tdata;
        else if ($key == 'Released')
            $nmj_data['RELEASE_DATE'] = $tdata;
        else if ($key == 'imdbRating')
            $nmj_data['RATING'] = $tdata;
        else if ($key == 'Plot')
            $nmj_data['CONTENT'] = $tdata;
        else if ($key == 'Rated')
            $nmj_data['PARENTAL_CONTROL'] = $tdata;
        else if ($key == 'Genre')
           $nmj_data['GENRE'] = explode(", ", $tdata);
        else if ($key == 'Director')
           $nmj_data['DIRECTOR'] = explode(", ", $tdata);
    }
    return ($nmj_data);
}

function getTMDBdata($imdbid)
{
    global $tmpdir, $TMDBAPI;

    $nmj_data['CONTENT_TTID'] = $imdbid;

    if (file_exists($tmpdir . "/cache." . $nmj_data['CONTENT_TTID']) && filesize($tmpdir . "/cache." . $nmj_data['CONTENT_TTID']) > 0)
        $data = file_get_contents($tmpdir . "/cache." . $nmj_data['CONTENT_TTID']);
    else {
        $command = "export LD_LIBRARY_PATH=/opt/syb/sigma/lib:/lib;wget 'http://api.themoviedb.org/3/movie/" .
        str_replace('tmdb','',$nmj_data['CONTENT_TTID']) . "?api_key=" . $TMDBAPI . "&language=".$nmj_data['LANG']."' -qO-";
        $data = shell_exec($command);
        file_put_contents($tmpdir . "/cache." . $nmj_data['CONTENT_TTID'], $data);
    }
    $json_parser = json_decode($data, true);

    foreach($json_parser as $key => $tdata){
        if ($key == 'title')
            $nmj_data['TITLE'] = $tdata;
        else if ($key == 'release_date') {
	    $nmj_data['RELEASE_DATE'] = $tdata;
            $nmj_data['YEAR'] = date('Y', strtotime($tdata));
        }
        else if ($key == 'imdb_id')
            $nmj_data['TTID'] = $tdata;
        else if ($key == 'vote_average')
            $nmj_data['RATING'] = strval($tdata);
        else if ($key == 'overview')
            $nmj_data['CONTENT'] = $tdata;
    }

    for($i=0;$i<count($json_parser['genres']);$i++) {
       $grow[]= $json_parser['genres'][$i]['name'];
    }
    if (is_array($grow))
        $nmj_data['GENRE'] = $grow;

    $command = "export LD_LIBRARY_PATH=/opt/syb/sigma/lib:/lib;wget http://api.themoviedb.org/3/movie/" .
    str_replace('tmdb','',$nmj_data['CONTENT_TTID']) . "/credits?api_key=" . $TMDBAPI . " -qO-";
    $data = shell_exec($command);
    $json_parser = json_decode($data, true);

    for($i=0;$i<count($json_parser['crew']);$i++) {
       if ($json_parser['crew'][$i]['job'] == 'Director')
           $drow[]= $json_parser['crew'][$i]['name'];
    }
    $nmj_data['DIRECTOR'] = $drow;

    $command = "export LD_LIBRARY_PATH=/opt/syb/sigma/lib:/lib;wget http://api.themoviedb.org/3/movie/" .
    str_replace('tmdb','',$nmj_data['CONTENT_TTID']) . "/releases?api_key=" . $TMDBAPI . " -qO-";
    $data = shell_exec($command);
    $json_parser = json_decode($data, true);
    $nmj_data['PARENTAL_CONTROL'] = $json_parser['countries'][0]['certification'];

    $command = "export LD_LIBRARY_PATH=/opt/syb/sigma/lib:/lib;wget http://api.themoviedb.org/3/movie/" .
    str_replace('tmdb','',$nmj_data['CONTENT_TTID']) . "/keywords?api_key=" . $TMDBAPI . " -qO-";
    $data = shell_exec($command);
    $json_parser = json_decode($data, true);

    for($i=0;$i<count($json_parser['keywords']);$i++) {
       $krow[]= $json_parser['keywords'][$i]['name'];
    }
    $nmj_data['KEYWORD'] = $krow;

    return($nmj_data);
}

function getMediaInfo($media_data)
{
    $mediainfo = trim(shell_exec("which mediainfo"));
    if (substr($media_data['VIDEO']['PATH'], 0, 6) == "smb://" || substr($media_data['VIDEO']['PATH'], 0, 6) == "nfs://")
        $mediafile = $media_data['VIDEO']['DRIVE']."/".str_replace($media_data['VIDEO']['SOURCEURL'], '', $media_data['VIDEO']['PATH']);
    else
        $mediafile = $media_data['VIDEO']['DRIVE']."/".$media_data['VIDEO']['PATH'];
    if (file_exists($mediafile)) {
    if ($mediainfo != "") {
        $command = $mediainfo." --Full --Output=XML";
        $cmd = $command . " \"" . $mediafile . "\"";
        $media_output = shell_exec($cmd);
        $xml = simplexml_load_string($media_output);
        $json = json_encode($xml);
        $array = json_decode($json,TRUE);

        foreach ($array['File']['track'][1] as $key => $value){
            if ($key == 'Width')
                $media_data['VIDEO']['WIDTH'] = $value[0];
            else if ($key == 'Height')
                $media_data['VIDEO']['HEIGHT'] = $value[0];
            else if ($key == 'Frame_rate')
                $media_data['VIDEO']['FPS'] = $value[0];
            else if ($key == 'Display_aspect_ratio')
                $media_data['VIDEO']['ASPECT_RATIO'] = $value[1];
            else if ($key == 'Writing_library_Name')
                $media_data['VIDEO']['VIDEO_CODEC'] = $value;
            else if ($key == 'Codecs_Video' )
                $media_data['VIDEO']['VIDEO_CODEC'] = $value;
        }
        foreach ($array['File']['track'][0] as $key => $value){
            if ($key == 'Format')
                $media_data['VIDEO']['SYSTEM'] = $value[0];
            else if ($key == 'File_size' )
                $media_data['VIDEO']['SIZE'] = $value[0];
            else if ($key == 'Duration' )
                $media_data['VIDEO']['RUNTIME'] = floor($value[0]/1000);
            else if ($key == 'Text_Language_List' )
                $media_data['VIDEO']['SUBTITLE']['INTERNAL'] = explode(" / ", $value);
        }
        if ($media_data['VIDEO']['HEIGHT'] != '' && $media_data['VIDEO']['WIDTH'] != '')
            $media_data['VIDEO']['RESOLUTION'] = $media_data['VIDEO']['WIDTH'] . 'x' . $media_data['VIDEO']['HEIGHT'];

        $media_data['VIDEO']['CREATE_TIME'] = date("Y-m-d H:i:s");
        $media_data['status'] = "success";
        $media_data['message'] = "Video details updated.";
    }
    else {
        $media_data['status'] = "error";
        $media_data['message'] = "Mediainfo binary not found.";
    }

    $media_woe_fpath = substr($media_data['VIDEO']['DRIVE'] . $media, 0, strrpos($media_data['VIDEO']['DRIVE'] . $media, "."));
    $media_woe = substr($media, 0, strrpos($media, "."));

    $extn = array(".srt", ".ssa", ".sub", ".idx");
    for($j=0;$j<count($extn);$j++) {
        if (file_exists($media_woe_fpath . $extn[$j]))
            $media_data['VIDEO']['SUBTITLE']['EXTERNAL'] = $media_woe . $extn[$j];
    }
    }
    else {
        $media_data['status'] = "error";
        $media_data['message'] = "File does not exist.";
    }
    return ($media_data);
}

function handleNMJData($dbh, $data, $mode)
{
    switch ($mode) {
        case "inserted":
            // Insert VIDEO_PERSON
            $data['castid'] = handleVideoPerson($dbh, $data, "insert");

            // Insert SHOW N VIDEO
            $data['SHOW_ID'] = handleShow($dbh, $data, "insert");
            $data['VIDEO_ID'] = handleVideo($dbh, $data, "insert");
            handleMediaInfo($dbh, $data, "update");

            $data['p_sql_data'] = getPosterData($data);
            handleImages($dbh, $data, "updated");

            $data['t_sql_data'] = getThumbnailData($data);
            handleShowThumbnail($dbh, $data, "update");
            handleVideoThumbnail($dbh, $data, "update");

            $data['w_sql_data'] = getWallpaperData($data);
            handleShowWallpaper($dbh, $data, "update");
            handleVideoWallpaper($dbh, $data, "update");

            // Insert VIDEO_ATTR
            handleSubtitle($dbh, $data, "inserted");
            handleGenre($dbh, $data, "inserted");
            if ($data['KEYWORD'] != '')
                handleKeyword($dbh, $data, "inserted");
            if ($data['DIRECTOR'] != '')
                handleDirector($dbh, $data, "insert");

            if (isset($data['synopsis']))
                handleVideoSynopsis($dbh, $data, "insert");

            if ((!isset($data['GROUPS_ID'])) || $data['GROUPS_ID'] == '')
                $data = handleVideoGroupName($dbh, $data, "insert");
            handleVideoGroup($dbh, $data, "insert");
            break;
        case "updated":
            // Update Show Poster
            if (isset($data['TITLE']))
                handleShow($dbh, $data, $mode);
            if (isset($data['CONTENT']))
                handleVideoSynopsis($dbh, $data, $mode);
            if (isset($data['GENRE']))
                handleGenre($dbh, $data, $mode);
            if (isset($data['KEYWORD']))
                handleKeyword($dbh, $data, $mode);
            if (isset($data['DIRECTOR']))
                handleDirector($dbh, $data, $mode);
            if (isset($data['POSTER']) || isset($data['THUMBNAIL']) || isset($data['WALLPAPER']))
                handleImages($dbh, $data, $mode);

            if ($data['GROUPS_CHANGED'] == 1)
                handleVideoGroup($dbh, $data, $mode);
            if ($data['SUBTITLE_CHANGED'] == 1)
                handleSubtitle($dbh, $data, $mode);

            if ($data['MEDIAINFO_CHANGED'] == 1)
                handleMediaInfo($dbh, $data, $mode);

            break;
        case "deleted":
            // Delete SHOW N VIDEO
            handleImages($dbh, $data, $mode);

            handleVideo($dbh, $data, $mode);
            handleShow($dbh, $data, $mode);

            handleSubtitle($dbh, $data, $mode);
            handleGenre($dbh, $data, $mode);
            handleKeyword($dbh, $data, $mode);
            handleDirector($dbh, $data, $mode);

            handleVideoSynopsis($dbh, $data, $mode);
            handleVideoGroup($dbh, $data, $mode);
            break;
    }
}

function getIMDBid($imdb_content)
{
    $imdb_content = str_replace("\n\r", "", $imdb_content);
    $imdb_content = str_replace("\r\n", "", $imdb_content);
    $imdb_content = str_replace("\n", "", $imdb_content);
    $imdb_content = str_replace("\r", "", $imdb_content);
    $no_popular_titles = 0;
    $exact_matches = 0;
    $movie = array();

    $result = preg_match("|<title>(.*)</title>|Ui", $imdb_content, $output);
    if ($result > 0) {
        if ($output[1] != "IMDb Title Search") {
            $result = preg_match("|<link rel=\"canonical\" href=\"http://www.imdb.com/title/(.*)/(.*)/>|Ui",
                $imdb_content, $output);
            if ($result > 0)
                return (strip_tags($output[1]));
        }
    }

    $result = preg_match("|<p><b>Popular Titles</b>(.*)</table>|Ui", $imdb_content, $output);
    if ($result > 0) {
        $result = preg_match_all("|<img src=\"(.*)\"(.*)<a href=\"/title/(.*)/(.*);\">(.*)</a> \((\d{4})\)(.*)</td></tr>|sUi", $output[0], $titles);
        if ($result > 0) {
            for ($i = 0; $i < count($titles[0]); $i++) {
                $movie[$i] = array_push_assoc($movie[$i], "ID", $titles[3][$i]);
                $movie[$i] = array_push_assoc($movie[$i], "NAME", str_replace('&#x22;', '"', $titles[5][$i]));
                $aka = explode("aka", strip_tags(trim(str_replace('&#x22;', '"', $titles[7][$i]))));
                $movie[$i] = array_push_assoc($movie[$i], "ALTERNATIVE_NAME", trim($aka[2]));
                $movie[$i] = array_push_assoc($movie[$i], "RELEASED", strip_tags(trim($titles[6][$i])));
                //if (strip_tags(trim($titles[1][$i])) == "/images/b.gif")
                $image = "";
                //else
                //$image = str_replace("_SY30_SX23_","_SX92_",strip_tags(trim($titles[1][$i])));
                $movie[$i] = array_push_assoc($movie[$i], "URL", $image);
            }
        }
    }

    $result = preg_match("|<p><b>Titles \(Exact Matches(.*)</table>|Ui", $imdb_content, $output);
    if ($result > 0) {
        $result = preg_match_all("|<img src=\"(.*)\"(.*)<a href=\"/title/(.*)/(.*);\">(.*)</a> \((\d{4}).*\)(.*)</td></tr>|sUi", $output[0], $titles);
        if ($result > 0) {
            $j = count($movie);
            for ($i = 0; $i < count($titles[0]); $i++) {
                $movie[$j + $i] = array_push_assoc($movie[$j + $i], "ID", $titles[3][$i]);
                $movie[$j + $i] = array_push_assoc($movie[$j + $i], "NAME", str_replace('&#x22;', '"', $titles[5][$i]));
                $aka = explode("aka", strip_tags(trim(str_replace('&#x22;', '"', $titles[7][$i]))));
                $movie[$j + $i] = array_push_assoc($movie[$j + $i], "ALTERNATIVE_NAME", trim($aka[1]));
                $movie[$j + $i] = array_push_assoc($movie[$j + $i], "RELEASED", strip_tags(trim($titles[6][$i])));
                //if (strip_tags(trim($titles[1][$i])) == "/images/b.gif")
                $image = "";
                //else
                //$image = str_replace("_SY30_SX23_","_SX92_",strip_tags(trim($titles[1][$i])));
                $movie[$j + $i] = array_push_assoc($movie[$j + $i], "URL", $image);
            }
        }
    }
    if (!isset($movie))
        return "No Matches";
    else if (count($movie) == 1)
        return $movie[0]['ID'];
    else
        return $movie;
}

function sec2hms($sec, $padHours = false)
{
    // start with a blank string
    $hms = "";

    // do the hours first: there are 3600 seconds in an hour, so if we divide
    // the total number of seconds by 3600 and throw away the remainder, we're
    // left with the number of hours in those seconds
    $hours = intval(intval($sec) / 3600);

    // add hours to $hms (with a leading 0 if asked for)
    $hms .= str_pad($hours, 2, "0", STR_PAD_LEFT) . ":";

    // dividing the total seconds by 60 will give us the number of minutes
    // in total, but we're interested in *minutes past the hour* and to get
    // this, we have to divide by 60 again and then use the remainder
    $minutes = intval(($sec / 60) % 60);

    // add minutes to $hms (with a leading 0 if needed)
    $hms .= str_pad($minutes, 2, "0", STR_PAD_LEFT) . ":";

    // seconds past the minute are found by dividing the total number of seconds
    // by 60 and using the remainder
    $seconds = intval($sec % 60);

    // add seconds to $hms (with a leading 0 if needed)
    $hms .= str_pad($seconds, 2, "0", STR_PAD_LEFT);

    // done!
    return $hms;

}

function sec2ms($sec, $padHours = false)
{
    // start with a blank string
    $hms = "";

    // do the hours first: there are 3600 seconds in an hour, so if we divide
    // the total number of seconds by 3600 and throw away the remainder, we're
    // left with the number of hours in those seconds
    $hours = intval(intval($sec) / 3600);

    // add hours to $hms (with a leading 0 if asked for)
    //$hms .= ($padHours)
    //        ? str_pad($hours, 2, "0", STR_PAD_LEFT) . "h:"
    //        : $hours . "h:";

    // dividing the total seconds by 60 will give us the number of minutes
    // in total, but we're interested in *minutes past the hour* and to get
    // this, we have to divide by 60 again and then use the remainder
    $minutes = intval(($sec / 60) % 60);

    // add minutes to $hms (with a leading 0 if needed)
    $hms .= str_pad($minutes, 2, "0", STR_PAD_LEFT) . ":";

    // seconds past the minute are found by dividing the total number of seconds
    // by 60 and using the remainder
    $seconds = intval($sec % 60);

    // add seconds to $hms (with a leading 0 if needed)
    $hms .= str_pad($seconds, 2, "0", STR_PAD_LEFT);

    // done!
    return $hms;

}

function sec2hm($sec, $padHours = false)
{
    // start with a blank string
    $hm = "";

    // do the hours first: there are 3600 seconds in an hour, so if we divide
    // the total number of seconds by 3600 and throw away the remainder, we're
    // left with the number of hours in those seconds
    $hours = intval(intval($sec) / 3600);

    if ($hours > 1)
        $hrtxt = "hrs ";
    else
        $hrtxt = "hr ";

    // add hours to $hm (with a leading 0 if asked for)
    $hm .= ($padHours)
        ? str_pad($hours, 2, "0", STR_PAD_LEFT) . $hrtxt
        : $hours . $hrtxt;

    // dividing the total seconds by 60 will give us the number of minutes
    // in total, but we're interested in *minutes past the hour* and to get
    // this, we have to divide by 60 again and then use the remainder
    $minutes = intval(($sec / 60) % 60);

    // add minutes to $hm (with a leading 0 if needed)
    $hm .= str_pad($minutes, 2, "0", STR_PAD_LEFT) . "min";

    // done!
    return $hm;

}

function DBQuery($dbh, $sql)
{
    //file_put_contents("sql.txt", $sql . "\n", FILE_APPEND);
    $result = $dbh->query($sql);
    $err = $dbh->errorInfo();
    if (!$result) {
        $dbh = NULL;
        $error = $sql."\n".$err[2];
        die($err[2]);
    } else {
        return $result;
    }
}

function handleList($dbh, $data, $mode)
{
    switch ($mode) {
        case "updated":
            $sql = 'SELECT ID FROM LISTS WHERE TITLE="'. $data['NAME'].'"';
            $result = DBQuery($dbh, $sql);
            $row = $result->fetch(PDO::FETCH_ASSOC);
            if (!isset($row['ID'])) {
                $sql = 'INSERT INTO LISTS VALUES(NULL,';
                $sql .= '"'.$data['NAME'].'",';
                $sql .= 'NULL,NULL,NULL,NULL,NULL,NULL)';
                DBQuery($dbh, $sql);
                $row['ID'] = $dbh->lastInsertId();
            }
            if (isset($row['ID'])) {
                $sql = 'SELECT ID AS LID FROM SHOWS_LISTS WHERE LIST_ID='.$row['ID'].' AND ';
                $sql .= 'SHOW_ID='.$data['SHOW_ID'];
                $result = DBQuery($dbh, $sql);
                $nrow = $result->fetch(PDO::FETCH_ASSOC);
                if (!isset($nrow['LID'])) {
                    $sql = 'INSERT INTO SHOWS_LISTS VALUES(NULL,' . $row['ID'] . ',';
                    $sql .= $data['SHOW_ID'] . ',NULL,NULL,NULL,NULL,NULL)';
                    $result = DBQuery($dbh, $sql);
                }
            }
            break;
        case "deleted":
            break;
    }
}

// Function to Add/Delete/Edit Genre
function handleCollections($dbh, $data, $mode)
{
    switch ($mode) {
        case "updated":
            $urltype = substr($data['POSTER'], 0, 4);
            if ($urltype == 'http') {
                $poster_url = str_replace("/w300/", "/original/", $data['POSTER']);
                $suffix = $data['TITLE'].".jpg";
                $poster_fname = "collection_". $row['ID'] . "_" . $suffix;
                $data['POSTER'] = "nmj_database/media/video/poster/" . $poster_fname;
                $command = 'wget -q "http://images1-focus-opensocial.googleusercontent.com/gadgets/proxy?url=' . $poster_url . '&resize_w=220&resize_h=330&container=focus" -O "' . $data['DRIVE'] . "/" . $data['POSTER'] . '"';
                shell_exec($command);
            }
            $sql = 'SELECT ID FROM COLLECTIONS WHERE CONTENT_TTID="tmdb' . $data['CONTENT_TTID'] . '"';
            $result = DBQuery($dbh, $sql);
            $row = $result->fetch(PDO::FETCH_ASSOC);
            if (!isset($row['ID'])) {
                $sql = 'INSERT INTO COLLECTIONS VALUES(NULL,"' . $data['TITLE'] . '",';
                $sql .= '"'.setXMLSafe($data['OVERVIEW']).'",';
                $sql .= '"'.$data['POSTER'].'",';
                $sql .= '"tmdb'.$data['CONTENT_TTID'].'",';
                $sql .= 'NULL,NULL,NULL,NULL,NULL)';
                DBQuery($dbh, $sql);
                $row['ID'] = $dbh->lastInsertId();
            }
            if (isset($row['ID'])) {
                for($i=0;$i<count($data['SHOW_ID']);$i++){
                    $sql = 'SELECT ID AS BID FROM SHOWS_COLLECTIONS WHERE COLLECTIONS_ID='.$row['ID'].' AND ';
                    $sql .= 'SHOW_ID='.$data['SHOW_ID'][$i];
                    $result = DBQuery($dbh, $sql);
                    $nrow = $result->fetch(PDO::FETCH_ASSOC);
                    if (!isset($nrow['BID'])) {
                        $sql = 'INSERT INTO SHOWS_COLLECTIONS VALUES(NULL,' . $row['ID'] . ',';
                        $sql .= $data['SHOW_ID'][$i] . ',NULL,NULL,NULL,NULL,NULL)';
                        DBQuery($dbh, $sql);
                    }
                }
            }
            break;
        case "deleted":
            break;
    }
}

// Function to Add/Delete/Edit Genre
function handleGenre($dbh, $data, $mode)
{
    switch ($mode) {
        case "inserted":
            if ($data['TITLE_TYPE'] != 2 || $data['TITLE_TYPE'] != 3 || $data['TITLE_TYPE'] != 4) {
                for ($i = 0; $i < count($data['GENRE']); $i++) {
                    $sql = 'SELECT ID FROM VIDEO_GENRES WHERE NAME="' . $data['GENRE'][$i] . '"';
                    $result = DBQuery($dbh, $sql);
                    $row = $result->fetch(PDO::FETCH_ASSOC);
                    if (!isset($row['ID'])) {
                        $sql = 'INSERT INTO VIDEO_GENRES VALUES(NULL,"' . $data['GENRE'][$i] . '",';
                        $sql .= 'NULL,NULL,NULL,NULL,NULL,NULL)';
                        DBQuery($dbh, $sql);
                        $row['ID'] = $dbh->lastInsertId();
                    }
                    if (isset($row['ID'])) {
                        $sql = 'INSERT INTO SHOWS_GENRES VALUES(NULL,' . $row['ID'] . ',';
                        $sql .= $data['SHOW_ID'] . ',NULL,NULL,NULL,NULL,NULL)';
                        DBQuery($dbh, $sql);
                    }
                }
            }
            return $result;
        break;
        case "updated":
            handleGenre($dbh, $data, "deleted");
            handleGenre($dbh, $data, "inserted");
        break;
        case "deleted":
            $sql = 'DELETE FROM SHOWS_GENRES WHERE SHOWS_ID=' . $data['SHOW_ID'];
            DBQuery($dbh, $sql);
        break;
    }
}

// Function to Add/Edit/Delete Keyword
function handleKeyword($dbh, $data, $mode)
{
    switch ($mode) {
        case "inserted":
            // Insert KEYWORD
                if ($data['TITLE_TYPE'] != 2 || $data['TITLE_TYPE'] != 3 ||
                    $data['TITLE_TYPE'] != 4) {
                    for ($i = 0; $i < count($data['KEYWORD']); $i++) {
                        $sql = 'SELECT ID FROM KEYWORDS WHERE KEYWORD="' . $data['KEYWORD'][$i] . '"';
                        $result = DBQuery($dbh, $sql);
                        $row = $result->fetch(PDO::FETCH_ASSOC);
                        if (!isset($row['ID'])) {
                            $sql = 'INSERT INTO KEYWORDS VALUES(NULL,"' . $data['KEYWORD'][$i] . '",';
                            $sql .= 'NULL,NULL,NULL,NULL,NULL,NULL)';
                            DBQuery($dbh, $sql);
                            $row['ID'] = $dbh->lastInsertId();
                        }
                        if (isset($row['ID'])) {
                            $sql = 'INSERT INTO SHOWS_KEYWORDS VALUES(NULL,' . $row['ID'] . ',';
                            $sql .= $data['SHOW_ID'] . ',NULL,NULL,NULL,NULL,NULL)';
                            DBQuery($dbh, $sql);
                        }
                    }
                }
            break;
        case "updated":
            handleKeyword($dbh, $data, "deleted");
            handleKeyword($dbh, $data, "inserted");
            break;
        case "deleted":
                $sql = 'DELETE FROM SHOWS_KEYWORDS WHERE SHOWS_ID=' . $data['SHOW_ID'];
                DBQuery($dbh, $sql);
            break;
    }
}

// Function to Add/Edit/Delete Director
function handleDirector($dbh, $data, $mode)
{
    switch ($mode) {
        case "inserted":
            // Insert DIRECTOR
            for ($i = 0; $i < count($data['DIRECTOR']); $i++) {
                $sql = 'SELECT ID FROM VIDEO_PERSONS WHERE NAME="' . $data['DIRECTOR'][$i] . '"';
                $result = DBQuery($dbh, $sql);
                $row = $result->fetch(PDO::FETCH_ASSOC);
                if (!isset($row['ID'])) {
                    $sql = 'INSERT INTO VIDEO_PERSONS VALUES(NULL,"' . $data['DIRECTOR'][$i] . '",';
                    $sql .= 'NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL)';
                    DBQuery($dbh, $sql);
                    $row['ID'] = $dbh->lastInsertId();
                }
                if (isset($row['ID'])) {
                    $sql = 'INSERT INTO SHOWS_PERSONS VALUES(NULL,' . $row['ID'] . ',';
                    $sql .= $data['SHOW_ID'] . ',"DIRECTOR",NULL,NULL,NULL,NULL,NULL)';
                    DBQuery($dbh, $sql);
                }
            }
            break;
        case "updated":
            handleDirector($dbh, $data, "deleted");
            handleDirector($dbh, $data, "inserted");
            break;
        case "deleted":
            $sql = 'DELETE FROM SHOWS_PERSONS WHERE SHOWS_ID=' . $data['SHOW_ID'];
            $sql .= ' AND PERSON_TYPE="DIRECTOR"';
            DBQuery($dbh, $sql);
            break;
    }
}

// Function to Add/Edit/Delete VideoAttr
function handleSubtitle($dbh, $nmj_data, $mode)
{
    switch ($mode) {
        // Insert
        case "inserted":
                if (isset($nmj_data['SUBTITLE']) && $nmj_data['SUBTITLE'] != '') {
                    $subtitle = explode("#", $nmj_data['SUBTITLE']);
                    for ($i = 0; $i < count($subtitle); $i++) {
                        $sql = 'INSERT INTO VIDEO_SUBTITLES VALUES(NULL,';
                        $sql .= $nmj_data['VIDEO_ID'] . ',';
                        $sql .= (strpos($subtitle[$i], "/") === false) ? 'NULL,' : '"' . $subtitle[$i] . '",';
                        $sql .= (strpos($subtitle[$i], "/") === false) ? '"' . $subtitle[$i] . '",' : '"EXTERNAL",';
                        $sql .= '0,';
                        $sql .= '"' . date("Y-m-d H:i:s") . '",';
                        $sql .= (strpos($subtitle[$i], "/") === false) ? '"INTERNAL",' : '"EXTERNAL",';
                        $sql .= 'NULL,NULL,NULL,NULL,NULL)';
                        DBQuery($dbh, $sql);
                    }
                }
            break;

        // Update
        case "updated":
            handleSubtitle($dbh, $nmj_data, "deleted");
            handleSubtitle($dbh, $nmj_data, "inserted");
            break;

        // Delete GENRE
        case "deleted":
            $sql = 'DELETE FROM VIDEO_SUBTITLES WHERE VIDEOS_ID=' . $nmj_data['VIDEO_ID'];
            DBQuery($dbh, $sql);
            break;
    }
}

function handleMediaInfo($dbh, $nmj_data, $mode)
{
    switch ($mode) {
        case "updated":
            $sql = 'UPDATE VIDEO_PROPERTIES SET ';
            $sql .= 'RUNTIME=' . $nmj_data['RUNTIME'] . ',';
            $sql .= 'RESOLUTION="' . $nmj_data['RESOLUTION'] . '",';
            $sql .= 'WIDTH="' . $nmj_data['WIDTH'] . '",';
            $sql .= 'HEIGHT="' . $nmj_data['HEIGHT'] . '",';
            $sql .= 'ASPECT_RATIO="' . $nmj_data['ASPECT_RATIO'] . '",';
            $sql .= 'SYSTEM="' . $nmj_data['SYSTEM'] . '",';
            $sql .= 'VIDEO_CODEC="' . $nmj_data['VIDEO_CODEC'] . '",';
            $sql .= 'FPS="' . $nmj_data['FPS'] . '" ';
            $sql .= ' WHERE ID=' . $nmj_data['VIDEO_ID'];
            DBQuery($dbh, $sql);
            break;
        case "deleted":
            $sql = 'DELETE FROM VIDEO_PROPERTIES WHERE VIDEOS_ID=' . $nmj_data['VIDEO_ID'];
            DBQuery($dbh, $sql);
            break;
    }
}

// Function to Add/Edit/Delete Show And Video
function setImageData($data)
{
    if (isset($data['POSTER']) && $data['POSTER'] != '') {
        $urltype = substr($data['POSTER'], 0, 4);
        if ($urltype == 'http') {
            $poster_url = str_replace("/w300/", "/original/", $data['POSTER']);
            //$suffix = basename(substr($data['VIDEO']['PATH'], 0, strrpos($data['VIDEO']['PATH'], "."))).".jpg";
            $suffix = basename($data['POSTER']);
            $poster_fname = "poster_s_" . $data['SHOW_ID'] . "_" . $suffix;
            $data['POSTER'] = "nmj_database/media/video/poster/" . $poster_fname;
            $command = 'wget -q "http://images1-focus-opensocial.googleusercontent.com/gadgets/proxy?url=' . $poster_url . '&resize_w=220&resize_h=330&container=focus" -O "' . $data['VIDEO']['DRIVE'] . "/" . $data['POSTER'] . '"';
            shell_exec($command);
        }
        else 
            $data['POSTER'] = str_replace(basename($data['DRIVE'])."/", "", $data['POSTER']);
    }
    if (isset($data['THUMBNAIL']) && $data['THUMBNAIL'] != '') {
        $urltype = substr($data['THUMBNAIL'], 0, 4);
        if ($urltype == 'http') {
            $thumb_url = str_replace("/w300/", "/original/", $data['THUMBNAIL']);
            //$suffix = basename(substr($data['VIDEO']['PATH'], 0, strrpos($data['VIDEO']['PATH'], "."))).".jpg";
            $suffix = basename($data['THUMBNAIL']);
            $thumb_fname = "thumbnail_s_" . $data['SHOW_ID'] . "_" . $suffix;
            $data['THUMBNAIL'] = "nmj_database/media/video/thumbnail/" . $thumb_fname;
            $command = 'wget -q "http://images1-focus-opensocial.googleusercontent.com/gadgets/proxy?url=' . $poster_url . '&resize_w=202&resize_h=303&container=focus" -O "' . $data['VIDEO']['DRIVE'] . "/" . $data['THUMBNAIL'] . '"';
            shell_exec($command);
        }
        else 
            $data['THUMBNAIL'] = str_replace(basename($data['DRIVE'])."/", "", $data['THUMBNAIL']);
    }
    if (isset($data['WALLPAPER']) && $data['WALLPAPER'] != '') {
        $urltype = substr($data['WALLPAPER'], 0, 4);
        if ($urltype == 'http') {
            $wallpaper_url = str_replace("/w300/", "/original/", $data['WALLPAPER']);
            //$suffix = basename(substr($data['VIDEO']['PATH'], 0, strrpos($data['VIDEO']['PATH'], "."))).".jpg";
            $suffix = basename($data['WALLPAPER']);
            $wall_fname = "wallpaper_s_" . $data['SHOW_ID'] . "_" . $suffix;
            $data['WALLPAPER'] = "nmj_database/media/video/poster/" . $wall_fname;
            $command = 'wget -q ' . $wallpaper_url . ' -O "' . $data['VIDEO']['DRIVE'] . "/" . $data['WALLPAPER'] . '"';
            shell_exec($command);
        }
        else 
            $data['WALLPAPER'] = str_replace(basename($data['DRIVE'])."/", "", $data['WALLPAPER']);
    }
    return $data;
}

// Function to Add/Edit/Delete Show And Video
function handleImages($dbh, $data, $mode)
{
    global $delete_images;
    switch ($mode) {
        case "updated":
            $data = setImageData($data);
            $sql = 'UPDATE VIDEO_POSTERS SET ';
            $tarry = array();
            if (isset($data['POSTER']))
                $tarry[] .= 'POSTER="' . $data['POSTER'] . '"';
            if (isset($data['THUMBNAIL']))
                $tarry[] .= 'THUMBNAIL="' . $data['THUMBNAIL'] . '"';
            if (isset($data['WALLPAPER']))
                $tarry[] .= 'WALLPAPER="' . $data['WALLPAPER'] . '"';
            $sql .= implode(",", $tarry);
            $sql .= ',TYPE="1",';
            $sql .= 'CREATE_TIME="' . date("Y-m-d H:i:s") . '" ';
            $sql .= 'WHERE ID=' . $data['SHOW_ID'];
            DBQuery($dbh, $sql);
        break;

        case "deleted":
            $sql = 'DELETE FROM VIDEO_POSTERS ';
            $sql .= 'WHERE ID=' . $data['SHOW_ID'];
            DBQuery($dbh, $sql);
        if ($delete_images == "yes") {
            if (file_exists($data['DRIVE_PATH'] . $row['POSTER']))
                unlink($data['DRIVE_PATH'] . $row['POSTER']);
            if (file_exists($data['DRIVE_PATH'] . $row['THUMBNAIL']))
                unlink($data['DRIVE_PATH'] . $row['THUMBNAIL']);
            if (file_exists($data['DRIVE_PATH'] . $row['WALLPAPER']))
                unlink($data['DRIVE_PATH'] . $row['WALLPAPER']);
        }
        break;
    }
}

// Function to Add/Edit/Delete Show And Video
function handleShow($dbh, $data, $mode)
{
    $search = array("A ", "An ", "The ", "Le ", "Les ", "&quot;");
    $data['SEARCH_TITLE'] = str_replace($search, "", $data['TITLE']);
    switch ($mode) {
        case "inserted":
                $sql = 'INSERT INTO SHOWS VALUES(NULL,';
                $sql .= '"' . $data['TITLE'] . '",';
                $sql .= '"' . $data['SEARCH_TITLE'] . '",';
                $sql .= 'NULL,1,';
                $sql .= '"' . $data['RELEASE_DATE'] . '",';
                $sql .= 'NULL,';
                $sql .= 'NULL,';
                $sql .= '"' . $data['RATING'] . '",';
                $sql .= 'NULL,';
                $sql .= 'NULL,';
                $sql .= 'NULL,';
                $sql .= $data['PARENTAL_CONTROL'] . ',';
                $sql .= 'NULL,';
                $sql .= 'NULL,';
                $sql .= 'NULL,';
                $sql .= 'NULL,';
                $sql .= $data['TITLE_TYPE'] . ',';
                $sql .= 'NULL,';
                $sql .= '"' . $data['CAST_ID'] . '",';
                $sql .= '3,';
                $sql .= '"' . $data['TTID'] . '",';
                $sql .= '0,NULL,NULL,NULL,NULL,NULL)';
                DBQuery($dbh, $sql);
                $showid = $dbh->lastInsertId();
            break;

        // Update
        case "updated":
            // Update Show
                $sql = 'UPDATE SHOWS SET TITLE="' . $data['TITLE'] . '",';
                $sql .= 'SEARCH_TITLE="' . $data['SEARCH_TITLE'] . '",';
                $sql .= 'YEAR="' . $data['YEAR'] . '",';
                $sql .= 'RELEASE_DATE="' . $data['RELEASE_DATE'] . '",';
                $sql .= 'RATING="' . $data['RATING'] . '",';
                $sql .= 'PARENTAL_CONTROL="' . $data['PARENTAL_CONTROL'] . '",';
                $sql .= 'UPDATE_STATE=6,';
                $sql .= 'TTID="' . $data['TTID'] . '" WHERE ID=' . $data['SHOW_ID'];
            DBQuery($dbh, $sql);
            break;

        // Delete
        case "deleted":
            // Check any VIDEO is using SHOW_ID
                $sql = 'DELETE FROM SHOWS WHERE ID=' . $data['SHOW_ID'];
                DBQuery($dbh, $sql);
            break;
    }
}

// Function to Add/Edit/Delete Show And Video
function handleVideo($dbh, $nmj_data, $mode)
{
    switch ($mode) {
        case "inserted":
                $sql = 'INSERT INTO VIDEOS VALUES(NULL,';
                $sql .= '"' . $nmj_data['PATH'] . '",';
                $sql .= 'NULL,';
                $sql .= 'NULL,';
                $sql .= '0,';
                $sql .= '"' . $nmj_data['RATING'] . '",';
                $sql .= 'NULL,';
                $sql .= 'NULL,';
                $sql .= 'NULL,';
                $sql .= 'NULL,';
                $sql .= '"' . $nmj_data['PARENTAL_RATING'] . '",';
                $sql .= 'NULL,';
                $sql .= 'NULL,';
                $sql .= '0,';
                $sql .= '0,';
                $sql .= '0,';
                $sql .= $nmj_data['SHOW_ID'] . ',';
                $sql .= '0,';
                $sql .= 'NULL,';
                $sql .= 'NULL,';
                $sql .= '"' . $nmj_data['CAST_ID'] . '",';
                $sql .= '2,';
                $sql .= 'NULL,NULL,';
                $sql .= '"' . $nmj_data['TTID'] . '",';
                $sql .= 'NULL,NULL,NULL,NULL,NULL,NULL)';
                DBQuery($dbh, $sql);
                $videoid = $dbh->lastInsertId();
                return $videoid;
            break;

        // Update
        case "updated":
                $sql = 'UPDATE VIDEOS SET ';
                $sql .= 'PATH="' . $nmj_data['PATH'] . '",';
                $sql .= 'UPDATE_STATE="6",';
                $sql .= 'SIZE=' . $nmj_data['SIZE'];
                $sql .= ' WHERE ID=' . $nmj_data['VIDEO_ID'];
                DBQuery($dbh, $sql);
            break;

        // Delete
        case "deleted":
                $sql = 'DELETE FROM VIDEOS WHERE ID=' . $nmj_data['VIDEO_ID'];
                DBQuery($dbh, $sql);
            break;
    }
}

// Function to Add/Edit/Delete Video Synopsis
function handleVideoSynopsis($dbh, $data, $mode)
{
    if ($data['CONTENT'] == '')
        $synopsis = 'NULL';
    else
        $synopsis = '"' . setXMLSafe($data['CONTENT']) . '"';
    switch ($mode) {
        case "inserted":
                $sql = 'INSERT INTO SYNOPSISES VALUES(' . $data['SHOW_ID'] . ',' . $synopsis . ',NULL,';
                $sql .= 'NULL,NULL,NULL,NULL,NULL)';
                DBQuery($dbh, $sql);
            break;

        // Update
        case "updated":
                $sql = 'SELECT SUMMARY FROM SYNOPSISES WHERE ';
                $sql .= 'ID=' . $data['SHOW_ID'];
                $result = DBQuery($dbh, $sql);
                $row = $result->fetch(PDO::FETCH_ASSOC);
                if (isset($row['SUMMARY'])) {
                    $sql = 'UPDATE SYNOPSISES SET SUMMARY=' . $synopsis . ' ';
                    $sql .= 'WHERE ID=' . $data['SHOW_ID'];
                    DBQuery($dbh, $sql);
                } else
                    handleVideoSynopsis($dbh, $data, "inserted");
            break;

        // Delete
        case "deleted":
            break;
    }
}

// Function to Add/Delete Video Group Name (i.e. movie by alphabet)
function handleVideoGroupName($dbh, $nmj_data, $mode)
{
    $search = array("A ", "An ", "The ", "Le ", "Les ", "&quot;");
    $replace = array("", "", "", "", "", "");
    if (isset($nmj_data['TITLE']))
        $alphabet = strtoupper(substr(str_replace($search, $replace, $nmj_data['TITLE']), 0, 1));
    switch ($mode) {
        case "inserted":
                $sql = 'SELECT ID FROM SHOW_GROUPS WHERE NAME="' . $alphabet . '"';
                $result = DBQuery($dbh, $sql);
                $row = $result->fetch(PDO::FETCH_ASSOC);
                if (!isset($row['ID'])) {
                    $sql = 'INSERT INTO SHOW_GROUPS VALUES(NULL,';
                    $sql .= '"' . $alphabet . '",NULL,"EN",NULL,NULL,NULL,NULL,NULL)';
                    DBQuery($dbh, $sql);
                    $nmj_data['GROUPS_ID'] = $dbh->lastInsertId();
                } else
                    $nmj_data['GROUPS_ID'] = $row['ID'];
            return $nmj_data;
            break;
    }
}

// Function to Add/Delete/Edit MPAA
function handleVideoGroup($dbh, $nmj_data, $mode)
{
    switch ($mode) {
        case "inserted":
                $sql = 'INSERT INTO SHOW_GROUPS_SHOWS VALUES(NULL,' . $nmj_data['GROUPS_ID'] . ',';
                $sql .= $nmj_data['SHOW_ID'] . ',"' . $nmj_data['TITLE_TYPE'] . '",';
                $sql .= 'NULL,NULL,NULL,NULL,NULL)';
                DBQuery($dbh, $sql);
            break;

        // Update
        case "updated":
                $sql = 'UPDATE SHOW_GROUPS_SHOWS SET GROUPS_ID=' . $nmj_data['GROUPS_ID'] . ',';
                $sql .= 'TITLE_TYPE=' . $nmj_data['TITLE_TYPE'];
                $sql .= ' WHERE SHOWS_ID=' . $nmj_data['SHOW_ID'];
                DBQuery($dbh, $sql);
            break;

        // Delete
        case "deleted":
                $sql = 'DELETE FROM SHOW_GROUPS_SHOWS WHERE SHOWS_ID=' . $nmj_data['SHOW_ID'];
                DBQuery($dbh, $sql);
            break;
    }
}

// Function to Add/Remove/Edit Person
function handleVideoPerson($dbh, $nmj_data, $mode)
{
    $cast = explode("#", $nmj_data['CAST']);
    $cast_array = array();
    $cast_array[0] = 0;
    switch ($mode) {
        case "inserted":
            // Insert
                for ($i = 0; $i < count($cast); $i++) {
                    $sql = 'SELECT ID FROM VIDEO_PERSONS WHERE ';
                    $sql .= 'NAME="' . $cast[$i] . '"';
                    $result = DBQuery($dbh, $sql);
                    $row = $result->fetch(PDO::FETCH_ASSOC);
                    if (!isset($row['ID'])) {
                        $sql = 'INSERT INTO "VIDEO_PERSONS" VALUES(NULL,';
                        $sql .= '"' . $cast[$i] . '",';
                        $sql .= 'NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL)';
                        DBQuery($dbh, $sql);
                        $row['ID'] = $dbh->lastInsertId();
                    }
                    if (isset($row['ID'])) {
                        $sql = 'INSERT INTO SHOWS_PERSONS VALUES(NULL,' . $row['ID'] . ',';
                        $sql .= $nmj_data['SHOW_ID'] . ',"CAST",NULL,NULL,NULL,NULL,NULL)';
                        DBQuery($dbh, $sql);
                    }
                }
            return $nmj_data;
            break;
        case "updated":
            handleVideoPerson($dbh, $nmj_data, "deleted");
            handleVideoPerson($dbh, $nmj_data, "inserted");
            return $nmj_data;
            break;
        case "deleted":
                $sql = 'DELETE FROM SHOWS_PERSONS WHERE SHOWS_ID=' . $nmj_data['SHOW_ID'];
                $sql .= ' AND PERSON_TYPE="CAST"';
                DBQuery($dbh, $sql);
            break;
    }
}

function print_version()
{
    global $homedir;
    $appinfo = $homedir . "/version.txt";
    if (file_exists($appinfo)) {
        $data = file_get_contents($appinfo);
        return trim($data);
    } else
        return "unknown";
}

function getDefaultImageFromTMDB($tmdbid)
{
    global $TMDBAPI;

    $data = shell_exec("export LD_LIBRARY_PATH=/opt/syb/sigma/lib:/lib;wget http://api.themoviedb.org/3/configuration?api_key=" . $TMDBAPI . " -qO-");
    $json_parser = json_decode($data, true);
    $config['base_url']= $json_parser['images']['base_url'];

    $command = "export LD_LIBRARY_PATH=/opt/syb/sigma/lib:/lib;wget http://api.themoviedb.org/3/movie/" .
    str_replace('tmdb','',$tmdbid) . "?api_key=" . $TMDBAPI . " -qO-";
    $data = shell_exec($command);
    $json_parser = json_decode($data, true);

    foreach($json_parser as $key => $tdata){
        if ($key == 'poster_path') {
            if ($tdata != '') {
                $nmj_data['THUMBNAIL'] = $config['base_url'].'w300'.$tdata;
                $nmj_data['POSTER'] = $config['base_url'].'w300'.$tdata;
            }
            else {
                $nmj_data['THUMBNAIL'] = '';
                $nmj_data['POSTER'] = '';
            }
        }
        else if ($key == 'backdrop_path') {
            if ($tdata != '')
                $nmj_data['WALLPAPER'] = $config['base_url'].'w1920'.$tdata;
            else
                $nmj_data['WALLPAPER'] = '';
        }
    }
    return($nmj_data);
}

function findMovies($input_folder)
{
    global $file_extensions;
    $count = 0;
    $movie_names = array();
    foreach ($input_folder as $folder) {
        if (file_exists($folder)) {
            $files = preg_find('/./', $folder, PREG_FIND_RECURSIVE);
            if ($files != false && count($files) > 0) {
                foreach ($files as $file) {
                    foreach ($file_extensions as $extension) {
                        if (strtoupper(substr(strrchr($file, "."), 1)) == $extension) {
                            if ($extension == "VOB") {
                                $folder_name = strtoupper(substr(strrchr(dirname($file), "/"), 1));
                                if ($folder_name == "VIDEO_TS") {
                                    $dvd_movie = basename(dirname(dirname($file)));
                                    if (array_search_r(dirname($file), $movie_names) == 0) {
                                        $movie_names[$count]['id'] = dirname($file);
                                        $movie_names[$count++]['name'] = $dvd_movie;
                                    }
                                } else {
                                    $movie_names[$count]['id'] = $file;
                                    $movie_names[$count++]['name'] = substr(basename($file), 0, strrpos(basename($file), "."));
                                }
                            } else if ($extension == "M2TS") {
                                $folder_name = strtoupper(substr(strrchr(dirname($file), "/"), 1));
                                if ($folder_name == "STREAM") {
                                    $parent_folder = basename(dirname(dirname($file)));
                                    if ($parent_folder == "BDMV")
                                        $bd_movie = basename(dirname(dirname(dirname($file))));
                                    else
                                        $bd_movie = basename(dirname(dirname($file)));
                                    if (array_search_r(dirname($file), $movie_names) == 0) {
                                        $movie_names[$count]['id'] = dirname($file);
                                        $movie_names[$count++]['name'] = $bd_movie;
                                    }
                                } else {
                                    $movie_names[$count]['id'] = $file;
                                    $movie_names[$count++]['name'] = substr(basename($file), 0, strrpos(basename($file), "."));
                                }
                            } else {
                                $mov_name = substr(basename($file), 0, strrpos(basename($file), "."));
                                $part_number = strtoupper(substr(strrchr($mov_name, "."), 1));
                                if ($part_number != "CD2" && $part_number != "CD3" &&
                                    $part_number != "CD4"
                                ) {
                                    $movie_names[$count]['id'] = $file;
                                    $movie_names[$count++]['name'] = substr(basename($file), 0, strrpos(basename($file), "."));
                                }
                            }
                            break;
                        }
                    }
                }
            }
        }
    }
    return $movie_names;
}

function readNFOFile($nfofile)
{
    $fp = fopen($nfofile, "r");
    $xdata = fread($fp, filesize($nfofile));
    fclose($fp);
    $xml_parser = xml_parser_create();
    xml_parse_into_struct($xml_parser, $xdata, $vals, $index);
    xml_parser_free($xml_parser);
    $genre_count = 0;
    $actor_count = 0;
    $nfo_array = array();
    $prev_tag = array();
    $director = array();
    $actor = array();

    foreach ($vals as $xml_elem) {
        if ($xml_elem['tag'] == 'TITLE')
            $nfo_array = array_push_assoc($nfo_array, "title", utf8_decode($xml_elem['value']));
        if ($xml_elem['tag'] == 'RATING')
            $nfo_array = array_push_assoc($nfo_array, "rating", $xml_elem['value']);
        if ($xml_elem['tag'] == 'YEAR')
            $nfo_array = array_push_assoc($nfo_array, "year", $xml_elem['value']);
        if ($xml_elem['tag'] == 'OUTLINE')
            $nfo_array = array_push_assoc($nfo_array, "synopsis", $xml_elem['value']);
        if ($xml_elem['tag'] == 'THUMB' && $xml_elem['level'] == 2)
            $nfo_array = array_push_assoc($nfo_array, "poster", $xml_elem['value']);
        if ($xml_elem['tag'] == 'THUMBS')
            $nfo_array = array_push_assoc($nfo_array, "posters", $xml_elem['value']);
        if ($xml_elem['tag'] == 'FANART')
            $nfo_array = array_push_assoc($nfo_array, "wallpaper", $xml_elem['value']);
        if ($xml_elem['tag'] == 'FANARTS')
            $nfo_array = array_push_assoc($nfo_array, "fanarts", $xml_elem['value']);
        if ($xml_elem['tag'] == 'CERTIFICATION') {
            $mpaa = explode(" / ", $xml_elem['value']);
            $arr = preg_grep("|USA:(.*)|", $mpaa);
            $arr = array_values($arr);
            if (count($arr) > 0)
                $mpaa = explode(":", $arr[0]);
            $nfo_array = array_push_assoc($nfo_array, "mpaa", $mpaa[1]);
        }
        if ($xml_elem['tag'] == 'ID') {
            if ($xml_elem['value'] != '') {
                $nfo_array = array_push_assoc($nfo_array, "imdbid", $xml_elem['value']);
            }
        }
        if ($xml_elem['tag'] == 'ID' && array_key_exists('attributes', $xml_elem) && $xml_elem['attributes']['MOVIEDB'] == 'tmdb')
            $nfo_array = array_push_assoc($nfo_array, "tmdbid", $xml_elem['value']);
        if ($xml_elem['tag'] == 'DIRECTOR') {
            $director = array_push_assoc($director, "name", utf8_decode($xml_elem['value']));
            $nfo_array = array_push_assoc($nfo_array, "director", $director);
        }
        if ($xml_elem['tag'] == 'GENRE') {
            $genre[$genre_count++] = $xml_elem['value'];
        }
        if ($xml_elem['tag'] == 'NAME' && $prev_tag == 'ACTOR') {
            $actor[$actor_count] = array_push_assoc($actor[$actor_count], "name", utf8_decode($xml_elem['value']));
            $principal_cast[$actor_count] = utf8_decode($xml_elem['value']);
        }
        if ($xml_elem['tag'] == 'THUMB' && $prev_tag == 'ACTOR') {
            $actor[$actor_count] = array_push_assoc($actor[$actor_count], "thumb", $xml_elem['value']);
            $actor_count++;
        }
        if ($xml_elem['tag'] == 'RELEASEDATE')
            $nfo_array = array_push_assoc($nfo_array, "release_date", date("Y-m-d", strtotime($xml_elem['value'])));
        $prev_tag = $xml_elem['tag'];
    }
    if (count($genre) == 1) {
        $genre = explode(" / ", $genre[0]);
        $nfo_array = array_push_assoc($nfo_array, "genre", $genre);
    } else
        $nfo_array = array_push_assoc($nfo_array, "genre", $genre);
    $nfo_array = array_push_assoc($nfo_array, "actor", $actor);
    $nfo_array = array_push_assoc($nfo_array, "principal_cast", $principal_cast);
    return $nfo_array;
}

function PrintArray($array)
{
    $string = '';
    foreach ($array as $key => $value) {
        $string .= $key . " => " . $value . "\n";
    }
    file_put_contents("array.txt", $string, FILE_APPEND);
}

function loadActorData($dbh, $showid, $drivepath, $ttype)
{
    global $TMDBAPI, $TVDBAPI;
    $nmj_data = array();

    $sql = "SELECT CONTENT_TTID FROM SHOWS WHERE ID=".$showid;
    $result = DBQuery($dbh, $sql);
    $tmdbid = $result->fetch(PDO::FETCH_ASSOC);

    $command = "export LD_LIBRARY_PATH=/opt/syb/sigma/lib:/lib;wget ";
    if ($ttype == 1) {
        $command .= "http://api.themoviedb.org/3/movie/";
        $command .= str_replace('tmdb','',$tmdbid['CONTENT_TTID']) . "/credits?api_key=" . $TMDBAPI . " -qO-";
        $data = shell_exec($command);
        $json_parser = json_decode($data, true);

        foreach($json_parser[cast] as $castdata){
            $cdata['name']=$castdata['name'];
            $cdata['character']=$castdata['character'];
            $cdata['id']=$castdata['id'];
            if ($castdata['profile_path'] != '')
            $cdata['thumbnail']='http://image.tmdb.org/t/p/w185'.$castdata['profile_path'];
            else
                $cdata['thumbnail']='';
            $cdata['TITLE_TYPE'] = $ttype;
            $nmj_data[] = $cdata;
        }
    }
    else if ($ttype == 5){
        $command .= "http://thetvdb.com/api/".$TVDBAPI."/series/";
        $command .= str_replace('tvdb','',$tmdbid['CONTENT_TTID']) . "/actors.xml -qO-";
        $data = shell_exec($command);

        $xml = simplexml_load_string($data);
        $json = json_encode($xml);
        $json_parser = json_decode($json, TRUE);

        foreach($json_parser['Actor'] as $castdata){
            $cdata['name']=$castdata['Name'];
            $cdata['character']=$castdata['Role'];
            $cdata['id']=$castdata['id'];
            if ($castdata['Image'] != '')
                $cdata['thumbnail']='http://thetvdb.com/banners/'.$castdata['Image'];
            else
                $cdata['thumbnail']='';
            $cdata['TITLE_TYPE'] = $ttype;
            $nmj_data[] = $cdata;
        }
    }
    return $nmj_data;
}

function aasort (&$array, $key) {
    $sorter=array();
    $ret=array();
    reset($array);
    foreach ($array as $ii => $va) {
        $sorter[$ii]=$va[$key];
    }
    arsort($sorter);
    $i=0;
    foreach ($sorter as $ii => $va) {
        $ret[$i++]=$array[$ii];
    }
    $array=$ret;
}

function loadMovieData($dbpath, $showid, $drivepath, $sourceurl)
{
    $nmj_data = array();
    $mediapath = dirname(dirname($dbpath));
    $dbh = new PDO('sqlite:' . $dbpath);
    $sql = 'SELECT SHOWS_ID AS SHOW_ID,VIDEOS_ID AS VIDEO_ID FROM SHOWS_VIDEOS ';
    $sql .= 'WHERE SHOWS_ID=' . $showid;
    $result = DBQuery($dbh, $sql);
    $nmj_data = $result->fetch(PDO::FETCH_ASSOC);

    $sql = 'SELECT SHOWS.TITLE,SHOWS.SEARCH_TITLE,SHOWS.RELEASE_DATE,SHOWS.UPDATE_STATE,';
    $sql .= 'SHOWS.RATING,SHOWS.PARENTAL_CONTROL,SHOWS.TOTAL_ITEM,SHOWS.THREE_D,';
    $sql .= 'SHOWS.YEAR,SHOWS.TTID,SHOWS.RUNTIME,SHOWS.TITLE_TYPE,';
    $sql .= 'SHOWS.CREATE_TIME,SHOWS.CONTENT_TTID,';
    $sql .= 'SYNOPSISES.SUMMARY AS CONTENT,VIDEO_POSTERS.POSTER,';
    $sql .= 'VIDEO_POSTERS.THUMBNAIL,VIDEO_POSTERS.WALLPAPER ';
    $sql .= 'FROM SHOWS,SYNOPSISES,VIDEO_POSTERS ';
    $sql .= 'WHERE SHOWS.ID=' . $nmj_data['SHOW_ID'] . ' AND ';
    $sql .= 'SYNOPSISES.ID=' . $nmj_data['SHOW_ID'] . ' AND ';
    $sql .= 'VIDEO_POSTERS.ID=' . $nmj_data['SHOW_ID'] . ' ';
    $sql .= ' ORDER BY SHOWS.ID';

    $result = DBQuery($dbh, $sql);
    $result_row = $result->fetch(PDO::FETCH_ASSOC);
    $nmj_data = array_merge($nmj_data, $result_row);

    $pos = strpos($nmj_data['THUMBNAIL'], "/share/nmj_database");
    if ($pos === false)
        $nmj_data['THUMBNAIL'] = ($nmj_data['THUMBNAIL']) ? basename($mediapath) . '/' . $nmj_data['THUMBNAIL'] : $nmj_data['THUMBNAIL'];
    else
        $nmj_data['THUMBNAIL'] = substr($nmj_data['THUMBNAIL'], 1);
    $pos = strpos($nmj_data['POSTER'], "/share/nmj_database");
    if ($pos === false)
        $nmj_data['POSTER'] = ($nmj_data['POSTER']) ? basename($mediapath) . '/' . $nmj_data['POSTER'] : $nmj_data['POSTER'];
    else
        $nmj_data['POSTER'] = substr($nmj_data['POSTER'], 1);
    if ($pos === false)
        $nmj_data['WALLPAPER'] = ($nmj_data['WALLPAPER']) ? basename($mediapath) . '/' . $nmj_data['WALLPAPER'] : $nmj_data['WALLPAPER'];
    else
        $nmj_data['WALLPAPER'] = substr($nmj_data['WALLPAPER'], 1);

    if (!isset($nmj_data['WALLPAPER']))
        $nmj_data['WALLPAPER'] = '';
    if (!isset($nmj_data['POSTER']))
        $nmj_data['POSTER'] = '';
    if (!isset($nmj_data['THUMBNAIL']))
        $nmj_data['THUMBNAIL'] = '';

    $nmj_data['CONTENT'] = html_entity_decode(str_replace("&rsquo;","'", $nmj_data['CONTENT']), ENT_QUOTES|ENT_HTML5);

    if ($nmj_data['PARENTAL_CONTROL'] == '')
        $nmj_data['PARENTAL_CONTROL'] = "NR";

    /*$sql = 'SELECT GROUPS_ID FROM SHOW_GROUPS_SHOWS ';
    $sql .= 'WHERE SHOWS_ID=' . $nmj_data['SHOW_ID'];
    $result = DBQuery($dbh, $sql);
    $result_row = $result->fetch(PDO::FETCH_ASSOC);
    $nmj_data = array_merge($nmj_data, $result_row);

    if (is_array($result_row)) {
        $sql = 'SELECT NAME AS GROUP_NAME FROM SHOW_GROUPS ';
        $sql .= 'WHERE ID=' . $result_row['GROUPS_ID'];
        $result = DBQuery($dbh, $sql);
        $result_row = $result->fetch(PDO::FETCH_ASSOC);
        if ($result_row)
            $nmj_data = array_merge($nmj_data, $result_row);
    }*/

    $sql = 'SELECT VIDEOS.SIZE,VIDEOS.PATH,VIDEO_PROPERTIES.RESOLUTION,VIDEO_PROPERTIES.WIDTH,';
    $sql .= 'VIDEOS.FILE_TYPE, VIDEOS.SCAN_DIRS_ID, VIDEOS.CREATE_TIME,VIDEOS.UPDATE_STATE,';
    $sql .= 'VIDEOS.FILE_STATUS,VIDEOS.THREE_D,VIDEO_PROPERTIES.RUNTIME,';
    $sql .= 'VIDEO_PROPERTIES.HEIGHT,VIDEO_PROPERTIES.ASPECT_RATIO,VIDEO_PROPERTIES.SYSTEM,';
    $sql .= 'VIDEO_PROPERTIES.VIDEO_CODEC,VIDEO_PROPERTIES.FPS,VIDEOS.PLAY_COUNT ';
    $sql .= 'FROM VIDEOS,VIDEO_PROPERTIES ';
    $sql .= 'WHERE VIDEOS.ID=' . $nmj_data['VIDEO_ID'] . ' AND VIDEO_PROPERTIES.ID=' . $nmj_data['VIDEO_ID'];
    $result = DBQuery($dbh, $sql);
    $result_row = $result->fetch(PDO::FETCH_ASSOC);
    $result_row['DRIVE'] = $drivepath;
    $result_row['SOURCEURL'] = $sourceurl;
    $nmj_data['VIDEO'] = $result_row;

    $sql = 'SELECT BOOKMARK_TIME,THUMBNAIL AS BOOKMARK_THUMBNAIL FROM VIDEO_BOOKMARKS ';
    $sql .= 'WHERE VIDEOS_ID=' . $nmj_data['VIDEO_ID'];
    $result = DBQuery($dbh, $sql);
    $result_row = $result->fetch(PDO::FETCH_ASSOC);
    if (is_array($result_row)) {
        $nmj_data = array_merge($nmj_data, $result_row);
        $nmj_data['BOOKMARK_SECONDS'] = $nmj_data['BOOKMARK_TIME'];
        $nmj_data['BOOKMARK_TIME'] = sprintf('%02d:%02d:%02d', ($nmj_data['BOOKMARK_TIME'] / 3600), ($nmj_data['BOOKMARK_TIME'] / 60 % 60), $nmj_data['BOOKMARK_TIME'] % 60);
    $pos = strpos($nmj_data['BOOKMARK_THUMBNAIL'], "/share/nmj_database");
    if ($pos === false)
        $nmj_data['BOOKMARK_THUMBNAIL'] = ($nmj_data['BOOKMARK_THUMBNAIL']) ? basename($mediapath) . '/' . $nmj_data['BOOKMARK_THUMBNAIL'] : $nmj_data['BOOKMARK_THUMBNAIL'];
    else
        $nmj_data['BOOKMARK_THUMBNAIL'] = substr($nmj_data['BOOKMARK_THUMBNAIL'], 1);
    }
    if (!isset($nmj_data['BOOKMARK_THUMBNAIL']))
        $nmj_data['BOOKMARK_THUMBNAIL'] = '';

    /*$sql = 'SELECT PERSONS_ID FROM SHOWS_PERSONS WHERE SHOWS_ID=' . $showid . ' AND PERSON_TYPE="CAST"';
    $cast_array[] = 0;
    foreach ($dbh->query($sql) as $cast_row)
        $cast_array[] = $cast_row['PERSONS_ID'];
    $cast_array[] = 0;

    $cnt=0;
    for ($z = 1; $z < count($cast_array) - 1; $z++) {
        $sql = 'SELECT NAME FROM VIDEO_PERSONS WHERE ID=' . $cast_array[$z];
        $result = $dbh->query($sql);
        $trow = $result->fetch(PDO::FETCH_ASSOC);
        $cast[$cnt] = html_entity_decode($trow['NAME'], ENT_QUOTES|ENT_HTML5);
        $cnt++;
    }
    if (is_array($cast))
        $nmj_data['CAST'] = $cast;
    else
        $nmj_data['CAST'] = array();*/

    $sql = 'SELECT GENRES_ID FROM SHOWS_GENRES WHERE SHOWS_ID=' . $showid;
    foreach ($dbh->query($sql) as $genre_row) {
        $sql = 'SELECT NAME FROM VIDEO_GENRES WHERE ID=' . $genre_row['GENRES_ID'];
        $result = DBQuery($dbh, $sql);
        $grow[] = $result->fetch(PDO::FETCH_COLUMN);
    }
    if (is_array($grow))
        $nmj_data['GENRE'] = $grow;
    else
        $nmj_data['GENRE'] = array();

    /*$sql = 'SELECT KEYWORDS_ID FROM SHOWS_KEYWORDS WHERE SHOWS_ID=' . $showid;
    foreach ($dbh->query($sql) as $key_row) {
        $sql = 'SELECT KEYWORD FROM KEYWORDS WHERE ID=' . $key_row['KEYWORDS_ID'];
        $result = DBQuery($dbh, $sql);
        $krow[] = $result->fetch(PDO::FETCH_COLUMN);
    }
    if (is_array($krow))
        $nmj_data['KEYWORD'] = $krow;
    else
        $nmj_data['KEYWORD'] = array();*/

    $sql = 'SELECT PERSONS_ID FROM SHOWS_PERSONS WHERE SHOWS_ID=' . $showid . ' AND PERSON_TYPE="DIRECTOR"';
    $cnt=0;
    foreach ($dbh->query($sql) as $cast_row) {
        $sql = 'SELECT NAME FROM VIDEO_PERSONS WHERE ID=' . $cast_row['PERSONS_ID'];
        $result = DBQuery($dbh, $sql);
        $trow = $result->fetch(PDO::FETCH_ASSOC);
        $drow[$cnt] = html_entity_decode($trow['NAME'], ENT_QUOTES|ENT_HTML5);
        $cnt++;
    }
    if (is_array($drow))
        $nmj_data['DIRECTOR'] = $drow;
    else
        $nmj_data['DIRECTOR'] = array();

    $sql = 'SELECT VIDEOS_ID FROM SHOWS_VIDEOS WHERE SHOWS_ID=' . $showid;
    $result = DBQuery($dbh, $sql);
    $videoid = $result->fetch();

    $sql = 'SELECT ID FROM FAVOURITES WHERE MEDIA_ID=' . $showid;
    $result = DBQuery($dbh, $sql);
    $favid = $result->fetch();
    if (isset($favid['ID']))
        $nmj_data['FAVOURITE'] = $favid['ID'];
    else
        $nmj_data['FAVOURITE'] = '';

    $sql = 'SELECT FILE_NAME,LANGUAGE,TYPE FROM VIDEO_SUBTITLES WHERE VIDEOS_ID=' . $videoid['VIDEOS_ID'];
    foreach ($dbh->query($sql) as $sub_row) {
        if ($sub_row['TYPE'] == 'INTERNAL')
            $srow[] = $sub_row['LANGUAGE'];
        else
            $srow[] = $sub_row['FILE_NAME'];
    }
    $nmj_data['SUBTITLE'] = $srow;
    if (isset($sub_row))
        $nmj_data['LANGUAGE'] = $sub_row['LANGUAGE'];
    else
        $nmj_data['LANGUAGE'] = "NONE";

    $nmj_data['DRIVE'] = str_replace("nmj_database/media.db", "", $drivepath);
    $nmj_data['DB_PATH'] = $dbpath;

    $sql = "SELECT count(*) FROM sqlite_master WHERE type='table' AND name='CHAPTERS'";
    $result = DBQuery($dbh, $sql);
    $exists = $result->fetch(PDO::FETCH_NUM);

    if ($exists[0] != 0) {
        $sql = 'SELECT CHAPTER,TITLE,RUNTIME FROM CHAPTERS WHERE ';
        $sql .= 'SHOW_ID=' . $nmj_data['SHOW_ID'] . ' ORDER BY CHAPTER';
        $result = DBQuery($dbh, $sql);
        $allchapters = $result->fetchAll(PDO::FETCH_ASSOC);
        if ($allchapters) {
            for($i=0;$i<count($allchapters);$i++) {
                $allchapters[$i]['RUNTIME_TEXT'] = sec2hms($allchapters[$i]['RUNTIME']);
                $allchapters[$i]['TITLE'] = html_entity_decode($allchapters[$i]['TITLE'], ENT_QUOTES|ENT_HTML5);
            }
            $nmj_data['CHAPTERS'] = $allchapters;
        }
    }
    if (! is_array($nmj_data['CHAPTERS'])) {
        $no_chapters = floor($nmj_data['RUNTIME'] / 600) + 1;
        $tdata=array();
        for ($z = 0; $z < $no_chapters - 1; $z++) {
            $tdata[$z]['CHAPTER'] = ($z + 1);
            $tdata[$z]['TITLE'] = 'Chapter ' . ($z + 1);
            $tdata[$z]['RUNTIME'] = (600 * $z);
            $tdata[$z]['RUNTIME_TEXT'] = sec2hms(600 * $z);
        }
        $nmj_data['CHAPTERS'] = $tdata;
    }
    return $nmj_data;
}

function loadSeasonData($dbh, $showid, $drivepath)
{
    $nmj_data = array();

    $sql = 'SELECT SHOWS.TITLE,SHOWS.SEARCH_TITLE,SHOWS.RELEASE_DATE,';
    $sql .= 'SHOWS.RATING,SHOWS.PARENTAL_CONTROL,SHOWS.TOTAL_ITEM,';
    $sql .= 'SHOWS.YEAR,SHOWS.TTID,SHOWS.RUNTIME,SHOWS.TITLE_TYPE,';
    $sql .= 'SHOWS.ID AS SHOW_ID,SHOWS.CREATE_TIME,SHOWS.CONTENT_TTID,';
    $sql .= 'SYNOPSISES.SUMMARY AS CONTENT,VIDEO_POSTERS.POSTER,';
    $sql .= 'VIDEO_POSTERS.THUMBNAIL,VIDEO_POSTERS.WALLPAPER ';
    $sql .= 'FROM SHOWS,SYNOPSISES,VIDEO_POSTERS ';
    $sql .= 'WHERE SHOWS.ID=' . $showid . ' AND ';
    $sql .= 'SYNOPSISES.ID=' . $showid . ' AND ';
    $sql .= 'VIDEO_POSTERS.ID=' . $showid;

    $result = DBQuery($dbh, $sql);
    $nmj_data = $result->fetch(PDO::FETCH_ASSOC);

    $sql = 'SELECT ID FROM FAVOURITES WHERE MEDIA_ID=' . $showid;
    $result = DBQuery($dbh, $sql);
    $favid = $result->fetch();
    $nmj_data['FAVOURITE'] = $favid['ID'];

    $sql = 'SELECT PERSONS_ID FROM SHOWS_PERSONS WHERE SHOWS_ID=' . $showid . ' AND PERSON_TYPE="CAST"';
    $cast_array[] = 0;
    foreach ($dbh->query($sql) as $cast_row)
        $cast_array[] = $cast_row['PERSONS_ID'];
    $cast_array[] = 0;

    for ($z = 1; $z < count($cast_array) - 1; $z++) {
        $sql = 'SELECT NAME FROM VIDEO_PERSONS WHERE ID=' . $cast_array[$z];
        $result = $dbh->query($sql);
        $trow = $result->fetch(PDO::FETCH_ASSOC);
        $cast[] = $trow['NAME'];
    }
    if (isset($cast))
        $nmj_data['CAST'] = $cast;
    else
        $nmj_data['CAST'] = '';

    $sql = 'SELECT GENRES_ID FROM SHOWS_GENRES WHERE SHOWS_ID=' . $showid;
    foreach ($dbh->query($sql) as $genre_row) {
        $sql = 'SELECT NAME FROM VIDEO_GENRES WHERE ID=' . $genre_row['GENRES_ID'];
        $result = DBQuery($dbh, $sql);
        $grow[] = $result->fetch(PDO::FETCH_COLUMN);
    }
    if (isset($grow))
        $nmj_data['GENRE'] = $grow;
    else
        $nmj_data['GENRE'] = '';

    $sql = 'SELECT KEYWORDS_ID FROM SHOWS_KEYWORDS WHERE SHOWS_ID=' . $showid;
    foreach ($dbh->query($sql) as $key_row) {
        $sql = 'SELECT KEYWORD FROM KEYWORDS WHERE ID=' . $key_row['KEYWORDS_ID'];
        $result = DBQuery($dbh, $sql);
        $krow[] = $result->fetch(PDO::FETCH_COLUMN);
    }
    if (isset($krow))
        $nmj_data['KEYWORD'] = $krow;
    else
        $nmj_data['KEYWORD'] = '';

    $sql = 'SELECT PERSONS_ID FROM SHOWS_PERSONS WHERE SHOWS_ID=' . $showid . ' AND PERSON_TYPE="DIRECTOR"';
    foreach ($dbh->query($sql) as $cast_row) {
        $sql = 'SELECT NAME FROM VIDEO_PERSONS WHERE ID=' . $cast_row['PERSONS_ID'];
        $result = DBQuery($dbh, $sql);
        $drow[] = $result->fetch(PDO::FETCH_COLUMN);
    }
    if (isset($drow))
        $nmj_data['DIRECTOR'] = $drow;
    else
        $nmj_data['DIRECTOR'] = '';

    $sql = 'SELECT VIDEOS_ID FROM SHOWS_VIDEOS WHERE SHOWS_ID=' . $showid;
    $result = DBQuery($dbh, $sql);
    $videoid = $result->fetch();

    $sql = 'SELECT FILE_NAME,LANGUAGE,TYPE FROM VIDEO_SUBTITLES WHERE VIDEOS_ID=' . $videoid['VIDEOS_ID'];
    foreach ($dbh->query($sql) as $sub_row) {
        if ($sub_row['TYPE'] == 'INTERNAL')
            $srow[] = $sub_row['LANGUAGE'];
        else
            $srow[] = $sub_row['FILE_NAME'];
    }
    if (isset($srow))
        $nmj_data['SUBTITLE'] = implode("#", $srow);
    if (isset($sub_row))
        $nmj_data['LANGUAGE'] = $sub_row['LANGUAGE'];
    else
        $nmj_data['LANGUAGE'] = "NONE";

    $nmj_data['DRIVE_PATH'] = $drivepath;

    return $nmj_data;
}

function loadMusicData($dbh, $albumid, $drivepath)
{
    $nmj_data = array();
    $sql = 'SELECT SONG_ALBUMS.ID AS ALBUM_ID,';
    $sql .= 'SONG_ALBUMS.TITLE,';
    $sql .= 'SONG_ALBUMS.RELEASE_DATE AS ALBUM_YEAR,';
    $sql .= 'SONG_PERSONS.NAME AS ALBUM_ARTIST,';
    $sql .= 'SONG_ALBUM_POSTERS.POSTER ';
    $sql .= 'FROM SONG_ALBUMS,SONG_PERSONS,SONG_ALBUM_POSTERS ';
    $sql .= 'WHERE SONG_ALBUMS.ID=' . $albumid . ' AND ';
    $sql .= 'SONG_PERSONS.ID=' . $albumid . ' AND ';
    $sql .= 'SONG_ALBUM_POSTERS.ID=' . $albumid . ' ';

    $result = DBQuery($dbh, $sql);
    $nmj_data = $result->fetch(PDO::FETCH_ASSOC);

    $sql = 'SELECT SONGS.TITLE, SONG_GENRES.NAME AS GENRE, SONGS.RUNTIME, ';
    $sql .= 'SONG_ALBUMS.TITLE AS ALBUM,SONG_PERSONS.NAME AS ARTIST, ';
    $sql .= 'SONG_ALBUMS_SONGS.SEQUENCE AS TRACK_NO ';
    $sql .= 'FROM SONGS, SONG_ALBUMS_SONGS, SONG_GENRES, SONG_GENRES_SONGS,';
    $sql .= 'SONG_ALBUMS, SONG_PERSONS_SONGS, SONG_PERSONS ';
    $sql .= 'WHERE SONG_ALBUMS_SONGS.ALBUMS_ID = ' . $albumid . ' AND ';
    $sql .= 'SONG_PERSONS_SONGS.SONGS_ID = SONGS.ID AND ';
    $sql .= 'SONG_PERSONS.ID = SONG_PERSONS_SONGS.PERSONS_ID AND ';
    $sql .= 'SONG_ALBUMS.ID = ' . $albumid . ' AND ';
    $sql .= 'SONG_GENRES_SONGS.SONGS_ID = SONGS.ID AND ';
    $sql .= 'SONG_GENRES.ID = SONG_GENRES_SONGS.GENRES_ID AND ';
    $sql .= 'SONG_ALBUMS_SONGS.SONGS_ID = SONGS.ID ';
    $sql .= 'ORDER BY SONG_ALBUMS_SONGS.SEQUENCE';

    $tracks = 0;
    foreach ($dbh->query($sql) as $track_data) {
        $tracks++;
        $nmj_data["ID_" . $track_data['TRACK_NO']] = $track_data['TITLE'] . '#' . sec2hms($track_data['RUNTIME']) . '#' . $track_data['ALBUM'] . '#' . $track_data['TRACK_NO'] . '#' . $track_data['GENRE'] . '#' . $track_data['ARTIST'];
    }
    //$nmj_data = array_merge($nmj_data, $result_row);

    $year = explode("-", $nmj_data['ALBUM_YEAR']);
    $nmj_data['ALBUM_YEAR'] = $year[0];
    $nmj_data['TRACKS'] = $tracks;
    $nmj_data['DRIVE_PATH'] = $drivepath;

    return $nmj_data;
}

function matchRegex($strContent, $strRegex, $intIndex = null)
{
    $arrMatches = null;
    preg_match_all($strRegex, $strContent, $arrMatches);
    if ($arrMatches === FALSE) return false;
    if ($intIndex != null && is_int($intIndex)) {
        if ($arrMatches[$intIndex]) {
            return $arrMatches[$intIndex][0];
        }
        return false;
    }
    return $arrMatches;
}

function clean_num($num)
{
    $pos = strpos($num, '.');
    if ($pos === false) { // it is integer number
        return $num;
    } else { // it is decimal number
        return rtrim(rtrim($num, '0'), '.');
    }
}

?>
