var is_firefox = navigator.userAgent.toLowerCase().indexOf('firefox') > -1;
var is_android = navigator.userAgent.toLowerCase().indexOf("android") > -1;
var sourcePath = "/var/www/db/guerilla/nmj_database/media.db";
nmjObject = localStorage.getItem('nmjSource');

var isChrome = !!window.chrome;              // Chrome 1+

if (typeof window.orientation !== 'undefined') {
    if (isChrome) {
        var winW = window.outerWidth;
        var realWidth = window.outerWidth;
        var realHeight = screen.height;
    }
} else {
    if (is_firefox && is_android) {
        var winW = screen.width;
        var realHeight = screen.height;
    }
    else {
        var winW = window.innerWidth;
        var realHeight = window.innerHeight;
    }
}
if (winW < realHeight) {
// Vertical Orientation
    var wallColumns = 4;
    var toolbarHeight = winW / 8;
}
else {
// Horizontal Orientation
    var wallColumns = 6;
    var toolbarHeight = realHeight / 8;
}
//var buttonWidth = toolbarHeight - 10;
var buttonWidth = 64;
var toolbarHeight = 64;
var thumbWidth = Math.round((winW - (wallColumns * 10)) / wallColumns);
var thumbHeight;
//thumbWidth = (winW / wallColumns);
//var defaultLoad = Math.round(realHeight / (thumbWidth * 1.5) + 4);

var musicWallViewJS = {
    view: 'dataview', select: 'single', scroll: 'y',
    type: {height: 230, width: thumbWidth, padding: 0, margin: 0},
    id: 'musicWallView',
    template: function (obj) {
        return musicWallViewHTML(obj);
    }
};

webix.protoUI({
    name: "vert-window",
    $init: function(){
        this.$ready.push(function(){
            this.attachEvent("onShow", function(){
                this.$view.className += " animated fadeInRight";
            });
        });
    }
}, webix.ui.window);

webix.protoUI({
    name: "bounce-window",
    $init: function(){
        this.$ready.push(function(){
            this.attachEvent("onShow", function(){
                this.$view.className += " animated bounceInDown";
            });
        });
    }
}, webix.ui.window);

webix.protoUI({
    name: "hori-window",
    $init: function(){
        this.$ready.push(function(){
            this.attachEvent("onShow", function(){
                this.$view.className += " animated fadeInUp";
            });
            /*this.attachEvent("onHide", function(){
                this.$view.style.display = "block";
                this.$view.className += " animated fadeOutRight";
            });*/
        });
    }
}, webix.ui.window);

function getCertificationImage(parental_rating) {
    parental_rating_img = "images/rating_ur.png";

    if (parental_rating == 'R')
        parental_rating_img = "images/common_mpaa_r.png";
    else if (parental_rating == 'PG-13')
        parental_rating_img = "images/common_mpaa_pg_13.png";
    else if (parental_rating == 'PG-15')
        parental_rating_img = "images/common_mpaa_pg_15.png";
    else if (parental_rating == 'PG')
        parental_rating_img = "images/common_mpaa_pg.png";
    else if (parental_rating == 'NC-17')
        parental_rating_img = "images/common_mpaa_nc_17.png";
    else if (parental_rating == 'G')
        parental_rating_img = "images/common_mpaa_g.png";
    else if (parental_rating == 'TV-MA')
        parental_rating_img = "images/tv_ma.png";
    else if (parental_rating == 'TV-14')
        parental_rating_img = "images/tv_14.png";
    else if (parental_rating == 'TV-PG')
        parental_rating_img = "images/tv_pg.png";
    else if (parental_rating == 'TV-G')
        parental_rating_img = "images/tv_g.png";
    else if (parental_rating == 'TV-Y')
        parental_rating_img = "images/tv_y.png";
    else if (parental_rating == 'TV-Y7')
        parental_rating_img = "images/tv_y7.png";
    else if (parental_rating == '12')
        parental_rating_img = "images/uk_12.png";
    else if (parental_rating == '12A')
        parental_rating_img = "images/uk_12a.png";
    else if (parental_rating == '15')
        parental_rating_img = "images/uk_15.png";
    else if (parental_rating == '18')
        parental_rating_img = "images/uk_18.png";
    else if (parental_rating == 'U')
        parental_rating_img = "images/uk_u.png";
    else if (parental_rating == 'R18')
        parental_rating_img = "images/uk_r18.png";
    return parental_rating_img;
}

function getRatingImage(rating) {
    rating = rating.replace(",", ".");
    var rating_img;
    if (rating == 0)
        rating_img = "images/common_star_0.png";
    if (rating <= 1 && rating > 0)
        rating_img = "images/common_star_1.png";
    else if (rating <= 2 && rating > 1)
        rating_img = "images/common_star_2.png";
    else if (rating <= 3 && rating > 2)
        rating_img = "images/common_star_3.png";
    else if (rating <= 4 && rating > 3)
        rating_img = "images/common_star_4.png";
    else if (rating <= 5 && rating > 4)
        rating_img = "images/common_star_5.png";
    else if (rating <= 6 && rating > 5)
        rating_img = "images/common_star_6.png";
    else if (rating <= 7 && rating > 6)
        rating_img = "images/common_star_7.png";
    else if (rating <= 8 && rating > 7)
        rating_img = "images/common_star_8.png";
    else if (rating <= 9 && rating > 8)
        rating_img = "images/common_star_9.png";
    else if (rating <= 10 && rating > 9)
        rating_img = "images/common_star_10.png";
    return rating_img;
}

var movieWallViewJS = {
    view: 'dataview',
    select: true,
    scroll: 'y',
    navigation: true,
    borderless: true,
    css: "mainbg",
    xCount: wallColumns,
    type: {
        css: "moviewall",
        width: "auto"
    },
    on: {
        onBeforeRender: function () {
            this.type.height = this.type.width * 1.5;
            thumbHeight = this.type.height;
        },
        onAfterLoad: function () {
            if (!this.count()) {
                webix.message("There is no data.");
            }
        },
        onAfterSelect: function() {
            webix.html.addCss( $$("movieWallView").getItemNode($$('movieWallView').getSelectedId()) , "animated shake");
        }
    },
    template: function (obj) {
        return movieWallViewHTML(obj);
    },
    id: 'movieWallView'
};

var seasonPopupJS = {
    view: "hori-window",
    css: "season_popup",
    headHeight: 60,
    head: {
        template: "",
        css: "seasonheader",
        id: "seasonHead"
    },
    body: {
        view: 'list', layout: 'x',
        id: 'seasonView',
        select: 'single',
        scroll: 'x', yCount: 1,
        css: 'season',
        animate: true,
        datatype: "json",
        type: {
            css: "seasonwall",
            width: "auto"
        },
        on: {
            onBeforeRender: function () {
                this.type.height = $$('movieWallView').type.height;
                this.type.width = $$('movieWallView').type.width;
            }
        },
        template: function (obj) {
            return movieWallViewHTML(obj);
        }
    },
    position: function (obj) {
        obj.width = obj.maxWidth;
        obj.top = obj.maxHeight - $$('movieWallView').type.height - 60;
        obj.left = 0;
        obj.height = $$('movieWallView').type.height + 60;
    },
    animate: true,
    id: "seasonPopup",
    modal: true,
    padding: 0
};

function chapterViewHTML(obj) {
    Template = "<div style='color: white;margin: 15px;font-family: Oswald, sans-serif;'><span style='font-size:24px;'>" + obj.TITLE + "</span><br/><span style='float: left;'>";
    if (typeof obj.EPISODE != 'undefined')
        Template += "Episode " + obj.EPISODE;
    else
        Template += "Chapter " + obj.CHAPTER;

    Template += "</span><span style='float: right;right: 20px;'>";
    if (typeof obj.RUNTIME_TEXT != 'undefined')
        Template += obj.RUNTIME_TEXT;
    else
        Template += obj.RUNTIME;

    Template += "</span></div>";
    return Template;
};

var chapterPopupJS = {
    view: "vert-window",
    css: "season_popup",
    headHeight: 0,
    body: {
        view: 'dataview',
        id: 'chapterView',
        select: 'single',
        scroll: 'y',
        css: 'season',
        animate: true,
        datatype: "json",
        type: {
            css: "moviewall"
        },
        on: {
            onBeforeRender: function () {
                this.type.height = 100;
                this.type.width = 400;
            }
        },
        template: function (obj) {
            return chapterViewHTML(obj);
        }
    },
    position: function (obj) {
        obj.height = obj.maxHeight;
        obj.top = 0;
        obj.width = 400;
        obj.left = obj.maxWidth - 400;
    },
    animate: true,
    id: "chapterPopup",
    modal: true,
    padding: 0
};

function loadWallpaper(imgtype) {
    if (imgtype == 'WALLPAPER') {
        width = 480;
        height = 270;
    }
    else {
        width = 300;
        height = 450;
    }

    var dataobj = $$('movieDetailView').data;
    XmlHttpRequest = webix.ajax().get("http://" + ipaddress + ":" + port + "/NMJManagerTablet_web/getData.php?" +
        "action=getImages&type=" + imgtype + "&tmdbid=" + dataobj.CONTENT_TTID, function (text) {
            images = JSON.parse(text);
            var viewsArray = [];
            for (var i = 0; i < images.length; i++) {
                viewsArray.push({
                    id: images[i].id,
                    css: "image",
                    template: img,
                    data: webix.copy(images[i])
                });
            }
            if (typeof $$('wallpaperCarousel') != 'undefined')
                $$('wallpaperCarousel').close();
            webix.ui(
                {
                    view: "bounce-window",
                    modal: true,
                    position: 'center',
                    head: "Select " + imgtype.toLowerCase(),
                    body: {
                        rows: [
                            {
                                view: "carousel",
                                id: "wallpaperCarouselList",
                                cols: viewsArray,
                                width: width,
                                height: height,
                                navigation: {
                                    type: "side"
                                }
                            },
                            {
                                cols: [{}, {
                                    view: "button", label: "Select",
                                    on: {
                                        onItemClick: function () {
                                            index = $$('wallpaperCarouselList').getActiveIndex();
                                            id = $$('wallpaperCarouselList').getActiveId();
                                            if (imgtype == 'WALLPAPER') {
                                                $$('movieDetailView').data.WALLPAPER = viewsArray[index].data.data.WALLPAPER.replace("w300", "w1280");
                                            }
                                            else {
                                                $$('movieDetailView').data.POSTER = viewsArray[index].data.data.POSTER;
                                                $$('movieDetailView').data.THUMBNAIL = viewsArray[index].data.data.POSTER;
                                            }
                                            $$('movieDetailView').refresh(id);
                                            $$('movie_save').show();
                                            $$('wallpaperCarousel').close();
                                        }
                                    }
                                },
                                    {},
                                    {
                                        view: "button", label: "Cancel",
                                        on: {
                                            onItemClick: function () {
                                                $$('wallpaperCarousel').close();
                                            }
                                        }
                                    },
                                    {}
                                ]
                            }
                        ]
                    },
                    id: "wallpaperCarousel",
                    css: "wallpaper"
                }
            ).show();
        }
    )
};

function img(obj) {
    if (typeof obj.WALLPAPER != 'undefined')
        return '<img src="' + obj.WALLPAPER + '" style="width:100%;" class="content" ondragstart="return false"/>'
    else
        return '<img src="' + obj.POSTER + '" style="height:100%;" class="content" ondragstart="return false"/>'
}

var settingsMenuMainJSON = [
    {id: 'settings', name: 'Settings', img: 'images/overview.png'}
]

var settingsMenuMainJS = {
    view: "popup",
    id: "settingsMenuMain",
    padding: 0,
    width: 165,
    body: {
        view: "list",
        id: "settingsListMain",
        autoheight: true,
        borderless: true,
        css: "mainmenu",
        scroll: true,
        animate: true,
        type: {
            height: 50
        },
        data: settingsMenuMainJSON,
        datatype: "json",
        template: "<img src='#img#' style='width:24px;vertical-align:middle;'></img>&nbsp;#name#",
        select: true,
        y_count: 3
    }
};

var settingsMenuDetailJSON = [
    {id: 'settings', name: 'Settings', img: 'images/overview.png'},
    {id: 'add_chapters', name: 'Add Chapters', img: 'images/chapters.png'},
    {id: 'edit', name: 'Edit', img: 'images/edit.png'},
    {id: 'identify', name: 'Identify Movie', img: 'images/search.png'},
    {id: 'delete', name: 'Delete Movie', img: 'images/delete.png'},
    {id: 'imdb', name: 'Open in IMDb', img: 'images/imdb.png'},
    {id: 'tmdb', name: 'Open in TMDb', img: 'images/tmdb.png'}
]

var editMenuDetailJSON = [
    {id: 'update_imdb', name: 'Data update from IMDb', img: 'images/imdb.png'},
    {id: 'update_tmdb', name: 'Data update from TMDb', img: 'images/tmdb.png'},
    {id: 'update_mediainfo', name: 'MediaInfo update', img: 'images/tmdb.png'}
]

var editMenuImageJSON = [
    {id: 'update_tmdb_img', name: 'Image update from TMDb', img: 'images/tmdb.png'},
    {id: 'edit_poster', name: 'Edit Poster', img: 'images/tmdb.png'},
    {id: 'edit_wallpaper', name: 'Edit Wallpaper', img: 'images/tmdb.png'}
]

var addListJSON = [
    {id: 'add_new', name: 'Add to New list', img: 'images/add.png'}
]

var addListJS = {
    view: "popup",
    id: "addListPopup",
    padding: 0,
    width: 250,
    body: {
        view: "list",
        id: "addListList",
        autoheight: true,
        borderless: true,
        scroll: true,
        animate: true,
        datatype: "json",
        type: {
            height: 50
        },
        css: "mainmenu",
        template: "<img src='images/add.png' style='width:24px;vertical-align:middle;'></img>&nbsp;#TITLE#",
        select: true,
        y_count: 3
    }
};

var editMenuImageJS = {
    view: "popup",
    id: "editMenuImage",
    padding: 0,
    width: 250,
    body: {
        view: "list",
        id: "editListImage",
        autoheight: true,
        borderless: true,
        scroll: true,
        animate: true,
        data: editMenuImageJSON,
        datatype: "json",
        type: {
            height: 50
        },
        css: "mainmenu",
        template: "<img src='#img#' style='width:24px;vertical-align:middle;'></img>&nbsp;#name#",
        select: true,
        y_count: 3
    }
};

var editMenuDetailJS = {
    view: "popup",
    id: "editMenuDetail",
    padding: 0,
    width: 250,
    body: {
        view: "list",
        id: "editListDetail",
        autoheight: true,
        borderless: true,
        scroll: true,
        animate: true,
        data: editMenuDetailJSON,
        datatype: "json",
        type: {
            height: 50
        },
        css: "mainmenu",
        template: "<img src='#img#' style='width:24px;vertical-align:middle;'></img>&nbsp;#name#",
        select: true,
        y_count: 3
    }
};

var settingsMenuDetailJS = {
    view: "popup",
    id: "settingsMenuDetail",
    padding: 0,
    width: 180,
    body: {
        view: "list",
        id: "settingsListDetail",
        autoheight: true,
        borderless: true,
        scroll: true,
        animate: true,
        data: settingsMenuDetailJSON,
        datatype: "json",
        type: {
            height: 50
        },
        css: "mainmenu",
        template: "<img src='#img#' style='width:24px;vertical-align:middle;'></img>&nbsp;#name#",
        select: true,
        y_count: 3
    }
};

var filterMenuJSON = [
    {id: 'genres', name: 'Genres', img: 'images/genres.png'},
    {id: 'certification', name: 'Certification', img: 'images/certification.png'},
    {id: 'rating', name: 'IMDb rating', img: 'images/rating.png'},
    {id: 'year', name: 'Release year', img: 'images/year.png'},
    {id: 'clear', name: 'Clear filters', img: 'images/filter.png'}
]

var filterMenuJS = {
    view: "popup",
    id: "filterMenu",
    width: 165,
    padding: 0,
    body: {
        view: "list",
        id: "filterList",
        autoheight: true,
        borderless: true,
        animate: true,
        datatype: "json",
        css: "mainmenu",
        type: {
            height: 50
        },
        data: filterMenuJSON,
        template: "<img src='#img#' style='width:24px;vertical-align:middle;'></img>&nbsp;#name#",
        select: true,
        y_count: 3
    }
};

function playHTML(obj) {
    Template = "<div style='color: white;margin: 10px;font-family: Oswald, sans-serif;'><span style='background-image:url(\"" + obj.THUMBNAIL + "\");background-size:160px 90px;display: inline-block;vertical-align: middle;width:160px;height:90px;'/><span style='float:right;margin-top:60px;margin-right:5px;'>" + obj.TIME_TEXT + "</span></span><span style='margin-left: 10px;font-size:24px;'>" + obj.TITLE + "</span></div>";
    return Template;
}

webix.protoUI({
    name: "menuspinner",
    defaults: {
        template: "<div style='width:100%;height:100%;margin-top:10px;text-align:left;'>\
        <div style='font-size: 20px;color: white;'>#top_label#</div><div style='font-size: 14px;color: white;'>#bottom_label#</div></div>"
    },
    $init: function (config) {
    },
    setValue: function (value1, value2) {
        this._settings.top_label = ((value1 != '') ? value1 : this._settings.top_label);
        this._settings.bottom_label = ((value2) ? value2 : this._settings.bottom_label);

        this._dataobj.firstChild.childNodes[1].innerHTML = ((value1 != '') ? value1 : this._settings.top_label);
        this._dataobj.firstChild.childNodes[2].innerHTML = ((value2 != '') ? value2 : this._settings.bottom_label);
        this.$setSize();
        //this._dataobj.firstChild.innerHTML = value1;
    },
    $getSize: function (x, y) {
        return webix.ui.view.prototype.$getSize.call(this, x, y);
    },
    $setSize: function (x, y) {
        x1 = Math.round(getTextWidth(this._settings.top_label, 'normal 20px sans-serif')) + 22;
        x2 = Math.round(getTextWidth(this._settings.bottom_label, 'normal 14px sans-serif')) + 22;
        if (x1 > x2)
            x = x1;
        else
            x = x2;
        if (webix.ui.view.prototype.$setSize.call(this, x, y)) {
            //this.$view.style.width = "auto";
            this.render();
        }
        this._dataobj.firstChild.style.backgroundImage = "url('images/spinner.png')";
        this._dataobj.firstChild.style.backgroundPosition = x - 30 + "px" + " 18px";
        this._dataobj.firstChild.style.backgroundRepeat = "no-repeat";
    },
    _set_inner_size: function () {
    }
}, webix.ui.button);

function loadMovieDetailView(that, id) {
    var index = that.getIndexById(id);
    var data = that.getItem(id);

    if (data.TITLE_TYPE == 1)
        action = "getMovieDetails";
    else if (data.TITLE_TYPE == 5)
        action = "getSeasonDetails";

    $$("movieDetailView").load("http://" + ipaddress + ":" + port + "/NMJManagerTablet_web/getData.php?" +
        "action=" + action + "&sourceurl=" + sourceURL + "&sourcepath=" + sourcePath + "&dbpath=" + dbPath + "&INDEX=" + index + "&showid=" + data.SHOW_ID, "json",
        function (text, json, http_request) {
            var dataobj = $$("movieDetailView").data;
            if (dataobj.FAVOURITE == '') {
                $$('mark_favourite').setValue('images/fav_unsel.png');
                $$('mark_favourite')._settings.image = 'images/fav_unsel.png';
                $$('mark_favourite').render();
            }
            else {
                $$('mark_favourite')._settings.image = 'images/fav_sel.png';
                $$('mark_favourite').render();
            }
            $$('detailSpinner').setValue(dataobj.TITLE, "Overview");
            $$('detailList').select('overview');
            if (typeof dataobj.VIDEO != 'undefined' && dataobj.VIDEO.PLAY_COUNT > 0) {
                $$('watched')._settings.image = 'images/watched.png';
                $$('watched').render();
            }
            else {
                $$('watched')._settings.image = 'images/unwatched.png';
                $$('watched').render();
            }
            $$('movieDetailView').show();
        });
}

var tdata = [
    {TITLE: 'Play from Bookmark', TIME: '00:00'},
    {TITLE: 'Play from beginning', TIME: '00:00'},
    {TITLE: 'Play from Chapter', TIME: '00:00'}
]

var playPopupJS = {
    view: "bounce-window",
    modal: true,
    id: "playPopup",
    width: 400,
    position: 'center',
    head: {
        template: "Play movie",
        css: "windowheader"
    },
    css: "mainmenu",
    body: {
        view: "dataview",
        id: "playList",
        css: "genreList",
        scroll: true,
        animate: true,
        template: function (obj) {
            return playHTML(obj);
        },
        type: {
            width: 460,
            height: 120
        },
        select: true,
        datatype: "json",
        yCount: 3,
    }
};

var genrePopupJS = {
    view: "bounce-window",
    id: "genrePopup",
    modal: true,
    position: 'center',
    width: 300,
    head: {
        css: "windowheader",
        template: "Select genre",
    },
    body: {
        view: "list",
        id: "genreList",
        scroll: true,
        animate: true,
        css: "mainmenu",
        type: {
            height: 50
        },
        template: "#name#",
        select: true,
        y_count: 3
    }
};

var certificationPopupJS = {
    view: "bounce-window",
    id: "certificationPopup",
    position: 'center',
    modal: true,
    width: 300,
    head: {
        template: "Select certification",
    },
    css: "mainmenu",
    body: {
        view: "list",
        id: "certificationList",
        css: "genreList",
        scroll: true,
        animate: true,
        css: "mainmenu",
        type: {
            height: 50
        },
        template: "#name#",
        select: true,
        y_count: 3
    }
};

var yearPopupJS = {
    view: "bounce-window",
    id: "yearPopup",
    modal: true,
    width: 300,
    position: 'center',
    head: {
        template: "Select year",
    },
    body: {
        view: "list",
        id: "yearList",
        css: "genreList",
        scroll: true,
        animate: true,
        css: "mainmenu",
        type: {
            height: 50
        },
        template: "#name#",
        select: true,
        y_count: 3
    }
};

var ratingPopupJS = {
    view: "bounce-window",
    id: "ratingPopup",
    modal: true,
    width: 300,
    position: 'center',
    head: {
        template: "Select rating",
    },
    body: {
        view: "list",
        id: "ratingList",
        css: "genreList",
        scroll: true,
        animate: true,
        css: "mainmenu",
        type: {
            height: 50
        },
        template: "#name#",
        select: true,
        y_count: 3
    }
};

var sortMenuJSON = [
    {id: 'title', name: 'Sort by title'},
    {id: 'release', name: 'Sort by release'},
    {id: 'duration', name: 'Sort by duration'},
    {id: 'rating', name: 'Sort by rating'},
    {id: 'date', name: 'Sort by date added'}
]

var sortMenuJS = {
    view: "popup",
    id: "sortMenu",
    width: 190,
    padding: 0,
    body: {
        view: "list",
        id: "sortList",
        autoheight: true,
        borderless: true,
        //scroll: true,
        animate: true,
        css: "mainmenu",
        type: {
            height: 50
        },
        datatype: "json",
        data: sortMenuJSON,
        template: "#name#",
        select: true,
        y_count: 3
    }
};

var mainMenuJSON = [
    {id: 'Videos', name: 'All Videos'},
    {id: 'Movies', name: 'Movies'},
    {id: 'TV Shows', name: 'TV Shows'},
    {id: 'Favorites', name: 'Favorites'},
    {id: 'Collections', name: 'Collections'},
    {id: 'Lists', name: 'Lists'},
    {id: 'Watched', name: 'Watched videos'},
    {id: 'Unwatched', name: 'Unwatched videos'},
    {id: 'Unidentified', name: 'Unidentified videos'},
    {id: 'Search', name: 'Search results'}
]

var mainMenuJS = {
    view: "popup",
    id: "mainMenu",
    padding: 0,
    autofit: false,
    width: 200,
    body: {
        view: "list",
        id: "mainList",
        borderless: true,
        autoheight: true,
        scroll: true,
        animate: true,
        type: {
            height: 50
        },
        css: "mainmenu",
        datatype: "json",
        data: mainMenuJSON,
        template: "#name#",
        select: true,
        on: {
            onAfterLoad: function () {
                this.select(this.getFirstId());
            }
        },
        y_count: 3
    }
};

var detailMenuJSON = [
    {id: 'overview', name: 'Overview'},
    {id: 'actors', name: 'Actors'}
]

var detailMenuJS = {
    view: "popup",
    id: "detailMenu",
    width: 165,
    padding: 0,
    autofit: false,
    body: {
        view: "list",
        id: "detailList",
        autoheight: true,
        borderless: true,
        scroll: true,
        animate: true,
        css: "mainmenu",
        type: {
            height: 50
        },
        datatype: "json",
        data: detailMenuJSON,
        template: "#name#",
        select: true,
        on: {
            onAfterLoad: function () {
                this.select(this.getFirstId());
            }
        },
        y_count: 3
    }
};

var actorMenuJSON = [
    {id: 'biography', name: 'Biography'},
    {id: 'filmography', name: 'Filmography - Movies'}
]

var actorMenuJS = {
    view: "popup",
    id: "actorMenu",
    width: 200,
    padding: 0,
    autofit: false,
    body: {
        view: "list",
        id: "actorList",
        scroll: true,
        animate: true,
        autoheight: true,
        borderless: true,
        css: "mainmenu",
        type: {
            height: 50
        },
        datatype: "json",
        data: actorMenuJSON,
        template: "#name#",
        select: true,
        on: {
            onAfterLoad: function () {
                this.select(this.getFirstId());
            }
        },
        y_count: 3
    }
}

function secondsToTime(secs) {
    var hours = Math.floor(secs / (60 * 60));

    var divisor_for_minutes = secs % (60 * 60);
    var minutes = Math.floor(divisor_for_minutes / 60);

    var divisor_for_seconds = divisor_for_minutes % 60;
    var seconds = Math.ceil(divisor_for_seconds);

    var obj = {
        "h": hours,
        "m": minutes,
        "s": seconds
    };
    return hours + ' hours ' + minutes + ' minutes ';
}

String.prototype.width = function (font) {
    var f = font || '12px arial',
        o = $('<div>' + this + '</div>')
            .css({'position': 'absolute', 'float': 'left', 'white-space': 'nowrap', 'visibility': 'hidden', 'font': f})
            .appendTo($('body')),
        w = o.width();

    o.remove();

    return w;
}

function reloadMusicWall(id) {
    $$("musicWallView").clearAll();
    $$("title").setValue(id.name + ": " + id.textContent);
    $$("musicWallView").load("http://" + ipaddress + ":" + port + "/NMJManagerTablet_web/getData.php?" +
    "action=getMusic&sourcepath=" + sourcePath + "&dbpath=" + dbPath + "&TYPE=" + id.name + "&VALUE=" + id.textContent);
    $$('musicWallView').show();
    webix.delay($$("Toolbar").showBatch, $$("Toolbar"), ["wall"], 550);
}

function playMedia(dataobj, media, type, time) {
    XmlHttpRequest = webix.ajax().get("http://" + ipaddress + ":" + port + "/NMJManagerTablet_web/getData.php", "action=playMedia&type=" + type + "&media=" + media + "&time=" + time);
}

function showMovieWall(id) {
    if (typeof id != 'undefined' && id != 'reload') {
        filterBy = id.name;
        selValue = id.textContent;
    }
    $$('movieWallView').clearAll();
    $$("movieWallView").load("http://" + ipaddress + ":" + port + "/NMJManagerTablet_web/getData.php?" +
        "&action=getMovies&sourcepath=" + sourcePath + "&dbpath=" + dbPath + "&orderby=" + orderBy + "&filterby=" + filterBy + "&sortby=" + sortBy +
        "&TYPE=" + loadType + "&VALUE=" + selValue, "json",
        function (text, xml, http_request) {
            var dataobj = JSON.parse(text);
            if (loadType == "Movies")
                txt = " movies";
            else
                txt = " videos";
            if (filterBy == 'All')
                $$("mainSpinner").setValue(loadType, dataobj.total_count + txt);
            else {
                $$("mainSpinner").setValue("Search results", dataobj.total_count + txt);
                $$('mainList').select('Search');
            }
            $$("Toolbar").showBatch("wall");
            if (typeof id != 'undefined' && id != 'reload')
                $$("movieWallView").scrollTo(0, 0);
            else
                $$("movieWallView").scrollTo(0, moviesxy.y);
            $$('movieWallView').show();
        });
}

function showEpisodes() {
    document.getElementById('dhx_episode_cover').style.display = 'block';

    var list = document.getElementById("episode_div");
    if (list.style.display == 'block')
        list.style.display = 'none';
    else
        list.style.display = 'block';
}

function findDivByAttribute(attribute) {
    var elements = document.getElementsByTagName("div");
    for (var h = 0; h < elements.length; h++) {
        if (elements[h].getAttribute("view_id") == attribute)
            return elements[h];
    }
}

function showPlayPopup() {
    $$('playPopup').show();
}

function showChapters(length) {
    $$('chapterPopup').show();
    $$('chapterView').clearAll();
    if (typeof $$('movieDetailView').data.CHAPTERS != 'undefined')
        $$('chapterView').parse($$('movieDetailView').data.CHAPTERS);
    else {
    }
}

function showEpisodeDetails(track) {
    var list = document.getElementsByClassName("episode_details");
    for (var i = 0; i < list.length; i++) {
        if (track == i + 1) {
            if (list[i].style.display == 'block')
                list[i].style.display = 'none';
            else
                list[i].style.display = 'block';
        }
        else
            list[i].style.display = 'none';
    }
}

function showMusicDetails(track) {
    var list = document.getElementsByClassName("music_details");
    for (var i = 0; i < list.length; i++) {
        if (track == i + 1) {
            if (list[i].style.display == 'block')
                list[i].style.display = 'none';
            else
                list[i].style.display = 'block';
        }
        else
            list[i].style.display = 'none';
    }
}

function showActorMoviesWallView(data) {
    if ($$('actorMoviesWallView').count() == 0)
        aname = 0;
    else
        aname = $$('actorMoviesWallView').getItem($$('actorMoviesWallView').getIdByIndex(0)).name;
    if (aname != data.name) {
        $$('actorMoviesWallView').clearAll();
        $$("actorMoviesWallView").load("http://" + ipaddress + ":" + port + "/NMJManagerTablet_web/getData.php?" +
            "action=getActorMovieDetails&sourcepath=" + sourcePath + "&dbpath=" + dbPath + "&actorid=" + data.id, "json",
            function (text, json, http_request) {
                $$('actorSpinner').setValue(data.name, "Filmography - Movies");
                $$('actorList').select('filmography');
                $$('actorMoviesWallView').show();
            });
    }
    else {
        $$('actorSpinner').setValue(data.name, "Filmography - Movies");
        $$('actorList').select('filmography');
        $$('actorMoviesWallView').show();
    }
}

function showActorWallView(data) {
    if ($$('actorWallView').count() == 0)
        ashowid = 0;
    else
        ashowid = $$('actorWallView').getItem($$('actorWallView').getIdByIndex(0)).show_id;
    if (ashowid != data.SHOW_ID) {
        $$('actorWallView').clearAll();
        $$("actorWallView").load("http://" + ipaddress + ":" + port + "/NMJManagerTablet_web/getData.php?" +
            "action=getActors&SHOW_ID=" + data.SHOW_ID + "&TITLE_TYPE=" + data.TITLE_TYPE + "&dbpath=" + dbPath + "&sourcepath=" + sourcePath, "json",
            function (text, json, http_request) {
                $$('detailSpinner').setValue(data.TITLE, "Actors");
                $$('detailList').select('actors');
                $$('actorWallView').show();
            });
    }
    else {
        $$('detailSpinner').setValue(data.TITLE, "Actors");
        $$('detailList').select('actors');
        $$('actorWallView').show();
    }
}

var movieDetailViewJS = {
    id: 'movieDetailView',
    view: 'template',
    type: {
        css: "moviedetail",
    },
    borderless: true,
    template: function (obj) {
        if (typeof obj.SHOW_ID != 'undefined') {
            return movieDetailViewHTML(obj);
        }
    },
    on: {
        onAfterLoad: function () {
            webix.html.addCss($$('movieDetailView').$view, ' animated zoomIn ');
            $$('Toolbar').showBatch('movie_detail');
            if (writable == 'yes') {
                $$('mark_favourite').show();
                $$('edit_detail').show();
                $$('edit_image').show();
                $$('watched').show();
            }
            else {
                $$('mark_favourite').hide();
                $$('edit_detail').hide();
                $$('edit_image').hide();
                $$('watched').hide();
            }
            $$('movie_save').hide();
        }
    }
};

var actorWallViewJS = {
    view: 'dataview',
    select: true,
    scroll: 'y',
    navigation: true,
    borderless: true,
    css: "mainbg",
    xCount: wallColumns,
    type: {
        css: "moviewall",
        width: "auto"
    },
    on: {
        onBeforeRender: function () {
            this.type.height = this.type.width * 1.5;
        },
        onAfterSelect: function() {
            webix.html.addCss( $$("actorWallView").getItemNode($$('actorWallView').getSelectedId()) , "animated shake");
        }
    },
    id: 'actorWallView',
    template: function (obj) {
        return movieWallViewHTML(obj);
    }
};

var actorDetailViewJS = {
    id: 'actorDetailView',
    view: 'template',
    template: function (obj) {
        if (typeof obj.name != 'undefined') {
            return actorDetailViewHTML(obj);
        }
    },
    on: {
        onAfterLoad: function () {
            webix.html.addCss($$('actorDetailView').$view, ' animated zoomIn ');
            $$('Toolbar').showBatch('actor_detail');
        }
    }
};

var actorMoviesWallViewJS = {
    view: 'dataview',
    select: true,
    scroll: 'y',
    navigation: true,
    borderless: true,
    css: "mainbg",
    xCount: wallColumns,
    type: {
        css: "moviewall",
        width: "auto"
    },
    on: {
        onBeforeRender: function () {
            this.type.height = this.type.width * 1.5;
        },
        onAfterSelect: function() {
            webix.html.addCss( $$("actorMoviesWallView").getItemNode($$('actorMoviesWallView').getSelectedId()) , "animated shake");
        }
    },
    id: 'actorMoviesWallView',
    template: function (obj) {
        return movieWallViewHTML(obj);
    }
};

var musicDetailViewJS = {
    id: 'MusicDetailView',
    view: 'template',
    template: function (obj) {
        if (typeof obj.tracks != 'undefined') {
            return musicDetailViewHTML(obj);
        }
    }
};

function loadNMJ() {
    var item = webix.storage.local.get("NMJ");
    if (item != null && IsJsonString(item)) {
        json = JSON.parse(item);
        cnt = 0;
        for (i = 0; i < json.machines.length; i++) {
            json.machines[i].id = json.machines[i].ipaddress;
            if (!$$('nmjSelectView').exists(json.machines[i].id))
                $$('nmjSelectView').add(json.machines[i], -1);
        }
    }
};

var nmjSelectViewJS = {
    id: 'nmjSelectView',
    view: 'dataview', select: 'single', scroll: 'y',
    xCount: 2,
    css: "mainbg",
    type: {height: 150, width: 'auto'},
    datatype: "json",
    template: function (obj) {
        if (typeof obj.ipaddress != 'undefined')
            return mainHTML(obj);
    }
};

var sourceSelectViewJS = {
    id: 'sourceSelectView',
    xCount: 1,
    css: "mainbg",
    view: 'dataview',
    scroll: 'y',
    padding: 0,
    type: {height: 60, width: 'auto', css: 'moviewall'},
    select: 'single',
    template: "<div class='source' style='font-family: Oswald, sand-serif;'><img src='#image#' style='margin:8px;vertical-align: middle;'>" +
    "<span style='font-size: 24px;top: 6px;position: relative;color:#fff9f2;'>#name#</span></div>"
};

var movieViewJS = {
    id: 'MovieView',
    view: "multiview",
    cells: [
        nmjSelectViewJS,
        sourceSelectViewJS,
        movieWallViewJS,
        musicWallViewJS,
        movieDetailViewJS,
        actorWallViewJS,
        actorDetailViewJS,
        actorMoviesWallViewJS,
        musicDetailViewJS
    ],
    on: {
        onViewChange: function () {
            switch (this.getActiveId()) {
                case 'nmjSelectView':
                    $$('Toolbar').showBatch('nmj');
                    break;
                case 'sourceSelectView':
                    $$('Toolbar').showBatch('source');
                    break;
                case 'movieWallView':
                    $$('Toolbar').showBatch('wall');
                    break;
                case 'movieDetailView':
                    $$('Toolbar').showBatch('movie_detail');
                    $$('chapters').show();
                    if (writable == 'no'){
                        $$('mark_favourite').hide();
                        $$('add_list').hide();
                    }
                    else {
                        $$('mark_favourite').show();
                        $$('add_list').show();
                    }
                    $$('detail_menu').show();
                    if ($$('movieDetailView').data.TITLE_TYPE == 5 || writable == 'no') {
                        $$('edit_detail').hide();
                        $$('edit_image').hide();
                        $$('watched').hide();
                    }
                    else {
                        $$('edit_detail').show();
                        $$('edit_image').show();
                        $$('watched').show();
                    }
                    if (machineType != 'NMT')
                        $$('movie_play').hide();
                    else
                        $$('movie_play').show();
                    break;
                case 'actorWallView':
                    $$('Toolbar').showBatch('movie_detail');
                    $$('mark_favourite').hide();
                    $$('movie_save').hide();
                    $$('movie_play').hide();
                    $$('watched').hide();
                    $$('chapters').hide();
                    $$('detail_menu').hide();
                    $$('edit_detail').hide();
                    $$('edit_image').hide();
                    break;
                case 'actorDetailView':
                case 'actorMoviesWallView':
                    $$('Toolbar').showBatch('actor_detail');
                    break;
            }
        }
    }
};


function updateData() {
    values = $$('updateTTIDForm').getValues();
    update_type = $$("editListDetail").getSelectedId();
    dataobj = $$("movieDetailView").data;
    if (update_type == 'update_tmdb') {
        dataobj.CONTENT_TTID = values.ttid;
        if (dataobj.CONTENT_TTID != 0 && dataobj.CONTENT_TTID.substring(0, 4) == 'tmdb') {
            webix.ajax("http://" + ipaddress + ":" + port + "/NMJManagerTablet_web/getData.php?" +
                "action=updateData&SHOWID=" + dataobj.SHOW_ID + "&tmdbid=" + dataobj.CONTENT_TTID,
                function (text) {
                    obj = JSON.parse(text);
                    if (obj.TITLE != 'undefined') {
                        webix.message('Successfully updated movie info.');
                        for (var attrname in obj) {
                            dataobj[attrname] = obj[attrname];
                        }
                        $$('movieDetailView').setValues(dataobj, true);
                        $$('movieDetailView').render();
                        $$('movie_save').show();
                    }
                    else {
                        webix.message({type: "error", text: "Error updating movie."});
                    }
                });
        }
    }
    else if (update_type == 'update_imdb') {
        dataobj.TTID = values.ttid;
        if (dataobj.TTID != 0 && dataobj.TTID.substring(0, 2) == 'tt') {
            webix.ajax().get("http://" + ipaddress + ":" + port + "/NMJManagerTablet_web/getData.php?" +
                    "action=updateData&SHOWID=" + dataobj.SHOW_ID + "&imdbid=" + dataobj.TTID,
                    function (text) {
                        obj = JSON.parse(text);
                        if (obj.TITLE != 'undefined') {
                            webix.message('Successfully updated movie info.');
                            for (var attrname in obj) {
                                dataobj[attrname] = obj[attrname];
                            }
                            $$('movieDetailView').setValues(dataobj, true);
                            $$('movieDetailView').render();
                            $$('movie_save').show();
                        }
                        else {
                            webix.message({type: "error", text: "Error updating movie."});
                        }
                    });
        }
    }    
}

var form1 = {
    view: "form", id: "updateTTIDForm", borderless: true, elements: [
        {view: "text", label: 'ID:', name: 'ttid', labelWidth: 100, placeholder: 'tt1234567'},
        {
            cols: [{
                view: "button", value: 'Update', click: function () {
                    if (this.getParentView().getParentView().validate()) {
                        updateData();
                        $$('updateTTIDPopup').hide()
                    }
                }, inputWidth: 100, align: 'center'
            },
                {
                    view: "button", align: 'center', value: 'Cancel', click: function () {
                    $$('updateTTIDPopup').hide()
                }, inputWidth: 100
                }
            ]
        }
    ],
    rules: {
        "ttid": webix.rules.isNotEmpty
    },
};

var form2 = {
    view: "form", id: "addNewListForm", borderless: true, elements: [
        {view: "text", label: 'Name:', name: 'list_name', labelWidth: 100, placeholder: 'IMDb Top 100'},
        {
            cols: [{
                view: "button", value: 'Add', click: function () {
                    if (this.getParentView().getParentView().validate()) {
                        addNewList();
                        $$('addNewListPopup').hide()
                    }
                }, inputWidth: 100, align: 'center'
            },
                {
                    view: "button", align: 'center', value: 'Cancel', click: function () {
                    $$('addNewListPopup').hide()
                }, inputWidth: 100
                }
            ]
        }
    ],
    rules: {
        "list_name": webix.rules.isNotEmpty
    },
};

var form = {
    view: "form", id: "addNMJForm", borderless: true, elements: [
        {
            view: "richselect",
            label: 'PCH Model:',
            name: 'model',
            value: 'a400',
            labelWidth: 200,
            yCount: "6",
            options: [
                {id: 'a400', value: "A400"},
                {id: 'a300', value: "A300"},
                {id: 'c200', value: "C200"},
                {id: 'a200', value: "A200"},
                {id: 'a210', value: "A210"}
            ]
        },
        {view: "text", label: 'IP Address/Hostname:', name: 'ipaddress', labelWidth: 200, placeholder: '0.0.0.0'},
        {view: "text", label: 'Port', name: 'port', labelWidth: 200, placeholder: '9999'},
        {
            view: "text",
            label: 'Display Name',
            css: 'addnmj',
            name: 'display_name',
            labelWidth: 200,
            placeholder: 'Friendly Name, ex. My-A400'
        },
        {
            cols: [{
                view: "button", value: 'Save', click: function () {
                    if (this.getParentView().getParentView().validate()) {
                        saveSettings();
                        $$('addNMJPopup').hide()
                    }
                }, inputWidth: 150, align: 'center'
            },
                {
                    view: "button", align: 'center', value: 'Cancel', click: function () {
                    $$('addNMJPopup').hide();
                }, inputWidth: 150
                }
            ]
        }
    ],
    rules: {
        "ipaddress": webix.rules.isNotEmpty,
        "port": webix.rules.isNumber
    },
};

var addNMJJS = {
    view: "bounce-window",
    id: "addNMJPopup",
    width: 450,
    position: 'center',
    modal: true,
    css: "mainmenu",
    head: {
        template: "Add a Popcornhour (200/300/400)",
        css: "windowheader"
    },
    body: webix.copy(form)
};

var updateTTIDJS = {
    view: "bounce-window",
    id: "updateTTIDPopup",
    width: 250,
    position: 'center',
    modal: true,
    css: "mainmenu",
    head: {
        template: "Enter a valid IMDb or TMDb ID",
        css: "windowheader"
    },
    body: webix.copy(form1)
};

var addNewListJS = {
    view: "bounce-window",
    id: "addNewListPopup",
    width: 350,
    position: 'center',
    modal: true,
    css: "mainmenu",
    head: {
        template: "Enter a Name for List",
        css: "windowheader"
    },
    body: webix.copy(form2)
};

function saveSettings() {
    values = $$('addNMJForm').getValues();
    if ($$('display_name').getValue() == '')
        values.display_name = values.model;
    values.id = values.ipaddress;
    if (!$$('nmjSelectView').exists(values.ipaddress)) {
        var item = webix.storage.local.get("NMJ");
        if (item != null && IsJsonString(item))
            json = JSON.parse(item);
        if (json == undefined) {
            var json = {machines: []};
        }
        json.machines.push(values);
        webix.storage.local.put("NMJ", JSON.stringify(json));
        $$('nmjSelectView').add(values, -1);
    }
    else {
        webix.alert({title: "Error adding machine", text: "Machine already exists", type: 'alert-error'});
    }
}

function IsJsonString(str) {
    try {
        JSON.parse(str);
    } catch (e) {
        return false;
    }
    return true;
}

function mainHTML(obj) {
    Template = "<div style='color: white;margin: 10px;font-family: Oswald, sans-serif;'><span style='background-image:url(\"images/" + obj.model + ".jpg\");background-size:120px 120px;display: inline-block;vertical-align: middle;width:120px;height:120px;'/></span><span style='margin-left: 10px;font-size:24px;'>" + obj.display_name + "&nbsp;&nbsp;(&nbsp;" + obj.ipaddress + "&nbsp;)</span><span style='width:32px;height:32px; float: right;><button class='webix_img_btn' style='line-height:50px;' type='button'><div class='webix_image' style='width:30px;height:30px;background-image:url(images/close.png);' onclick='removeMachine(\"" + obj.id + "\");'></button></div></div>";
    return Template;
}

function removeMachine(id) {
    $$('nmjSelectView').select(id);
    $$('nmjSelectView').unselect(id);
    $$('nmjSelectView').remove(id);
    remaining = $$('nmjSelectView').serialize();
    if (json == undefined) {
        var json = {machines: []};
    }
    json.machines = remaining;
    webix.storage.local.put("NMJ", JSON.stringify(json));
}

var toolBarJS = {
    view: 'toolbar',
    height: toolbarHeight,
    id: 'Toolbar',
    visibleBatch: "nmj",
    cols: [
        {
            view: "button", type: "image", id: "icon", batch: "nmj",
            width: buttonWidth, align: 'left', image: 'images/movie1.png', css: 'settings', disabled: true
        },
        {batch: "nmj"},
        {
            view: "button",
            type: "image",
            id: "add",
            batch: "nmj",
            align: "right",
            image: "images/add.png",
            width: buttonWidth,
            css: 'settings',
            click: function () {
                $$('addNMJPopup').show();
            }
        },
        {
            view: "button",
            type: "image",
            id: "source_menu",
            batch: "nmj",
            popup: "settingsMenuMain",
            width: buttonWidth,
            image: 'images/settings.png',
            css: 'settings'
        },
        ///////
        {
            batch: "wall", cols: [
            {
                view: "button",
                type: "image",
                id: "back",
                batch: "wall",
                width: buttonWidth,
                image: 'images/movie1.png'
            },
            {
                view: "menuspinner",
                id: "mainSpinner",
                batch: "wall",
                top_label: "Videos",
                bottom_label: "",
                align: 'left',
                css: 'menuspinner',
                //popup: "mainMenu",
                click: function () {
                    $$('mainMenu').show(this.$view, {x: 2, y: 60});
                }
            }]
        },
        {
            view: "button",
            type: "image",
            id: "search_back",
            batch: "search",
            width: buttonWidth,
            image: 'images/movie1.png'
        },
        {
            view: "search",
            align: "right",
            batch: "search",
            placeholder: "Title, Keyword or Cast",
            id: "msearch",
            width: 300,
            hidden: true,
            inputWidth: 300,
        },
        {
            view: "segmented",
            id: "stype",
            batch: "search",
            value: "title",
            width: 300,
            options: [
                {id: 'title', value: "Title"},
                {id: 'keyword', value: "Keyword"},
                {id: 'cast', value: "Cast"},
            ],
            on: {
                onChange: function (id) {
                    filtermode = id;
                }
            }
        },
        {
            view: "button",
            type: "image",
            id: "search",
            batch: "wall",
            image: "images/search.png",
            width: buttonWidth,
            on: {
                onItemClick: function () {
                    $$('Toolbar').showBatch('search');
                    moviesxy = $$("movieWallView").getScrollState();
                    lastURL = $$('movieWallView').data.url;
                    $$('msearch').setValue('');
                    $$('msearch').focus();
                }
            }
        },
        {
            view: "button",
            type: "image",
            id: "sort_image",
            batch: "wall",
            image: "images/sort_asc.png",
            width: buttonWidth,
            popup: "sortMenu"
        },
        {
            view: "button",
            type: "image",
            id: "filter",
            batch: "wall",
            image: "images/filter.png",
            width: buttonWidth,
            popup: "filterMenu"
        },
        {
            view: "button",
            type: "image",
            id: "refresh",
            batch: "wall",
            image: "images/refresh.png",
            width: buttonWidth,
            click: function() {
                moviesxy = $$("movieWallView").getScrollState();
                if (loadType == "Collections" && writable == 'yes') {
                    webix.confirm({
                        title:"Collection refresh confirm",
                        ok:"Yes", 
                        cancel:"Cancel",
                        text:"Do you want to create/update Collections?",
                        callback:function(result){
                            if (result) {
                                webix.message('Updating collections...');
                                webix.message('It may take a while...');
                            webix.ajax("http://" + ipaddress + ":" + port + "/NMJManagerTablet_web/getData.php?" +
                                "action=updateCollections&dbpath=" + dbPath,
                                function (text) {
                                    obj = JSON.parse(text);
                                    if (obj.status == 'success')
                                        webix.message('Collections updated.');
                                    else {
                                        webix.message('Failed to update collections.');
                                        webix.message(obj.code);
                                    }
                                }
                            )
                            }
                        }
                    });
                }
                else
                    showMovieWall('reload');
            }
        },
        {
            view: "button",
            type: "image",
            id: "wall_menu",
            batch: "wall",
            popup: "settingsMenuMain",
            width: buttonWidth,
            image: 'images/settings.png'
        },
        //{ view: "imagebutton", id: "menu", batch: "source", popup: "", label: "",
        //    width: 48, align: 'left', src: 'images/Movie-48.png', css: 'nmjicon'},
        //{ view: "button", id: "menu", batch: "wall", popup: "MainMenu", label: "Menu",
        //   inputWidth: 80, align: 'left'},
        //{ view: "text", placeholder: 'Search', label: "", id: "search", batch: "wall", inputWidth: 300, type: "text",
        //    align: "right"},
        {
            batch: "movie_detail", cols: [{
            view: "button",
            type: "image",
            id: "detail_back",
            batch: "movie_detail",
            width: buttonWidth,
            image: 'images/movie1.png',
            css: 'nmjicon'
        },
            {
                view: "menuspinner",
                id: "detailSpinner",
                batch: "movie_detail",
                top_label: "10,000 BC",
                bottom_label: "Overview",
                css: 'menuspinner1',
                //popup: "detailMenu"
                click: function () {
                    $$('detailMenu').show(this.$view, {x: 2, y: 60});
                }
            }]
        },
        {
            view: "button",
            type: "image",
            id: "movie_save",
            batch: "movie_detail",
            image: "images/save.png",
            width: buttonWidth,
            css: 'settings',
        },
        {
            view: "button",
            type: "image",
            id: "movie_play",
            batch: "movie_detail",
            image: "images/play.png",
            width: buttonWidth,
            css: 'settings',
            click: "showPlayPopup"
        },
        {
            view: "button",
            type: "image",
            id: "add_list",
            batch: "movie_detail",
            image: "images/collection.png",
            width: buttonWidth,
            css: 'settings',
            click: function() {
                $$('addListList').clearAll();
                $$('addListList').load("http://" + ipaddress + ":" + port + "/NMJManagerTablet_web/getData.php?" + "action=getLists&sourceurl=" + sourceURL + "&sourcepath=" + sourcePath + "&dbpath=" + dbPath, "json");
                $$('addListPopup').show(this.$view, {x: 2, y: 2});
            }
        },
        {
            view: "button",
            type: "image",
            id: "mark_favourite",
            batch: "movie_detail",
            image: "images/fav_unsel.png",
            width: buttonWidth,
            css: 'settings',
            click: function() {
                webix.html.addCss($$('mark_favourite').$view, ' animated bounceIn');
                setTimeout(function(){
                    webix.html.removeCss($$('mark_favourite').$view, ' animated bounceIn');
                }, 1000);
                handleFavorite();
            }
        },
        {
            view: "button",
            type: "image",
            id: "chapters",
            batch: "movie_detail",
            image: "images/chapters.png",
            width: buttonWidth,
            css: 'settings',
            click: function() {
                webix.html.addCss($$('chapters').$view, ' animated bounceIn');
                setTimeout(function(){
                    webix.html.removeCss($$('chapters').$view, ' animated bounceIn');
                }, 1000);
                showChapters();
            }
        },
        {
            view: "button",
            type: "image",
            id: "watched",
            batch: "movie_detail",
            image: "images/watched.png",
            width: buttonWidth,
            css: 'settings',
            click: function() {
                webix.html.addCss($$('watched').$view, ' animated bounceIn');
                setTimeout(function(){
                    webix.html.removeCss($$('watched').$view, ' animated bounceIn');
                }, 1000);
                handleWatched();
            }
        },
        {
            view: "button",
            type: "image",
            id: "edit_image",
            css: 'settings',
            batch: "movie_detail",
            image: "images/edit_image.png",
            popup: "editMenuImage",
            width: buttonWidth
        },
        {
            view: "button",
            type: "image",
            id: "edit_detail",
            css: 'settings',
            batch: "movie_detail",
            image: "images/edit_detail.png",
            popup: "editMenuDetail",
            width: buttonWidth
        },
        {
            view: "button",
            type: "image",
            id: "detail_menu",
            batch: "movie_detail",
            popup: "settingsMenuDetail",
            width: buttonWidth,
            css: 'settings',
            image: 'images/settings.png'
        },
        {
            view: "button",
            type: "image",
            id: "actor_back",
            batch: "actor_detail",
            popup: "",
            width: buttonWidth,
            align: 'left',
            css: 'settings',
            image: 'images/movie1.png',
            css: 'nmjicon'
        },
        {
            view: "menuspinner",
            id: "actorSpinner",
            batch: "actor_detail",
            align: "left",
            top_label: "",
            bottom_label: "Biography",
            css: 'menuspinner1',
            //popup: "actorMenu"
            click: function () {
                $$('actorMenu').show(this.$view, {x: 2, y: 60});
            }
        },
        {
            view: "button",
            type: "image",
            id: "source_back",
            batch: "source",
            width: buttonWidth,
            align: 'left',
            css: 'settings',
            image: 'images/movie1.png'
        },
        {batch: "source"},
        {
            view: "segmented",
            id: "sourceType",
            batch: "source",
            align: "center",
            width: 300,
            options: [
                {value: "Local Media"},
                {value: "Network Media"}
            ]
        },
        {batch: "source"},
        /*{ view: "toggle", id: "togg", batch: "movie_detail", align: "center",
         options: [
         {label: "View", value: 1},
         {label: "Edit", value: 2}
         ]
         },*/
        {
            view: "button",
            id: "season_play",
            batch: "season_detail",
            css: 'settings',
            label: "Play",
            inputWidth: 80,
            align: 'right'
        },
        {
            view: "button",
            id: "music_play",
            batch: "music_detail",
            css: 'settings',
            label: "Play Album",
            inputWidth: 120,
            align: 'right'
        }
    ]
};

function getTextWidth(text, font) {
    var canvas = getTextWidth.canvas || (getTextWidth.canvas = document.createElement("canvas"));
    var context = canvas.getContext("2d");
    context.font = font;
    var metrics = context.measureText(text);
    return metrics.width;
};

var nmj = {
    rows: [
        toolBarJS,
        movieViewJS
    ], id: 'layout'
};

var movieTabbarJS = {
    borderless: true, view: "tabbar", id: 'tabbar', value: 'listView', multiview: true, options: [
        {id: 'Videos', value: 'All Videos'},
        {id: 'Movies', value: 'Movies'},
        {id: 'TV Shows', value: 'TV Shows'},
        {id: 'Favorites', value: 'Favorites'},
        {id: 'Collections', value: 'Collections'},
        {id: 'Watched', value: 'Watched videos'},
        {id: 'Unwatched', value: 'Unwatched videos'},
        {id: 'Unidentified', value: 'Unidentified videos'}
    ]
};

function handleMediaInfo() {
    var dataobj = $$('movieDetailView').data;
    webix.ajax("http://" + ipaddress + ":" + port + "/NMJManagerTablet_web/getData.php?" +
    "action=handleMediaInfo&sourcepath=" + sourcePath + "&dbpath=" + dbPath + "&TTYPE=1&showid=" + dataobj.SHOW_ID, {
        error: function (text, data, XmlHttpRequest) {
            webix.message("Error");
        },
        success: function (text, data, XmlHttpRequest) {
            webix.message("success");
            if (mode == "add")
                dataobj.FAVOURITE = 1;
            else
                dataobj.FAVOURITE = "";

            if (loadType == 'Favorites')
                reloadRequired = 1;

            if (dataobj.FAVOURITE == '') {
                $$('mark_favourite')._settings.image = 'images/fav_unsel.png';
                $$('mark_favourite').render();
            }
            else {
                $$('mark_favourite')._settings.image = 'images/fav_sel.png';
                $$('mark_favourite').render();
            }
        }
    });

}

function addNewList() {
    values = $$('addNewListForm').getValues();

    var dataobj = $$('movieDetailView').data;
    webix.ajax("http://" + ipaddress + ":" + port + "/NMJManagerTablet_web/getData.php?" +
    "action=updateList&sourcepath=" + sourcePath + "&dbpath=" + dbPath + "&listname=" + values.list_name + "&showid=" + dataobj.SHOW_ID, {
        error: function (text, data, XmlHttpRequest) {
            webix.message("Error getting JSON.");
        },
        success: function (text, data, XmlHttpRequest) {
            webix.message("Added to list " + values.list_name);
        }
    });
}

function handleFavorite() {
    var dataobj = $$('movieDetailView').data;
    if (dataobj.FAVOURITE == "")
        mode = "add";
    else
        mode = "remove";
    webix.ajax("http://" + ipaddress + ":" + port + "/NMJManagerTablet_web/getData.php?" +
    "action=editFavorite&sourcepath=" + sourcePath + "&dbpath=" + dbPath + "&TTYPE=1&mode=" + mode + "&showid=" + dataobj.SHOW_ID, {
        error: function (text, data, XmlHttpRequest) {
            webix.message("Error");
        },
        success: function (text, data, XmlHttpRequest) {
            webix.message("success");
            if (mode == "add")
                dataobj.FAVOURITE = 1;
            else
                dataobj.FAVOURITE = "";

            if (loadType == 'Favorites')
                reloadRequired = 1;

            if (dataobj.FAVOURITE == '') {
                $$('mark_favourite')._settings.image = 'images/fav_unsel.png';
                $$('mark_favourite').render();
            }
            else {
                $$('mark_favourite')._settings.image = 'images/fav_sel.png';
                $$('mark_favourite').render();
            }
        }
    });
}

function handleWatched() {
    var dataobj = $$('movieDetailView').data;
    var dataobj_wall = $$('movieWallView').getSelectedItem();
    if (dataobj.VIDEO.PLAY_COUNT == 0)
        mode = "add";
    else
        mode = "remove";
    webix.ajax("http://" + ipaddress + ":" + port + "/NMJManagerTablet_web/getData.php?" +
    "action=editWatched&sourcepath=" + sourcePath + "&dbpath=" + dbPath + "&TTYPE=1&mode=" + mode + "&showid=" + dataobj.SHOW_ID, {
        error: function (text, data, XmlHttpRequest) {
            webix.message("Error");
        },
        success: function (text, data, XmlHttpRequest) {
            if (mode == "add") {
                dataobj.VIDEO.PLAY_COUNT += 1;
                dataobj_wall.PLAY_COUNT += 1;
            }
            else {
                dataobj.VIDEO.PLAY_COUNT = 0;
                dataobj_wall.PLAY_COUNT = 0;
            }
            $$('movieDetailView').render();
            $$('movieWallView').render($$('movieWallView').getSelectedId(), dataobj_wall);
            if (dataobj.VIDEO.PLAY_COUNT == 0) {
                $$('watched')._settings.image = 'images/unwatched.png';
                $$('watched').render();
            }
            else {
                $$('watched')._settings.image = 'images/watched.png';
                $$('watched').render();
            }
        }
    });
}

// Handy JavaScript to meature the size taken to render the supplied text;
// you can supply additional style information too if you have it to hand.

function measureText(pText, pFontSize, pStyle) {
    var lDiv = document.createElement('lDiv');

    document.body.appendChild(lDiv);

    if (pStyle != null) {
        lDiv.style = pStyle;
    }
    lDiv.style.fontSize = "" + pFontSize + "px";
    lDiv.style.position = "absolute";
    lDiv.style.left = -1000;
    lDiv.style.top = -1000;

    lDiv.innerHTML = pText;

    var lResult = {
        width: lDiv.clientWidth,
        height: lDiv.clientHeight
    };

    document.body.removeChild(lDiv);
    lDiv = null;

    return lResult;
}
